(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(require('substance'), require('../dist/vendor.js')) :
	typeof define === 'function' && define.amd ? define(['substance', '../dist/vendor.js'], factory) :
	(factory(global.substance,global.vendor));
}(this, (function (substance,___dist_vendor_js) { 'use strict';

var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {}

function interopDefault(ex) {
	return ex && typeof ex === 'object' && 'default' in ex ? ex['default'] : ex;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var _arrayMap = createCommonjsModule(function (module) {
/**
 * A specialized version of `_.map` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the new mapped array.
 */
function arrayMap(array, iteratee) {
  var index = -1,
      length = array ? array.length : 0,
      result = Array(length);

  while (++index < length) {
    result[index] = iteratee(array[index], index, array);
  }
  return result;
}

module.exports = arrayMap;
});

var _arrayMap$1 = interopDefault(_arrayMap);


var require$$6 = Object.freeze({
	default: _arrayMap$1
});

var _listCacheClear = createCommonjsModule(function (module) {
/**
 * Removes all key-value entries from the list cache.
 *
 * @private
 * @name clear
 * @memberOf ListCache
 */
function listCacheClear() {
  this.__data__ = [];
  this.size = 0;
}

module.exports = listCacheClear;
});

var _listCacheClear$1 = interopDefault(_listCacheClear);


var require$$4$1 = Object.freeze({
	default: _listCacheClear$1
});

var eq = createCommonjsModule(function (module) {
/**
 * Performs a
 * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * comparison between two values to determine if they are equivalent.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 * @example
 *
 * var object = { 'a': 1 };
 * var other = { 'a': 1 };
 *
 * _.eq(object, object);
 * // => true
 *
 * _.eq(object, other);
 * // => false
 *
 * _.eq('a', 'a');
 * // => true
 *
 * _.eq('a', Object('a'));
 * // => false
 *
 * _.eq(NaN, NaN);
 * // => true
 */
function eq(value, other) {
  return value === other || (value !== value && other !== other);
}

module.exports = eq;
});

var eq$1 = interopDefault(eq);


var require$$3$1 = Object.freeze({
	default: eq$1
});

var _assocIndexOf = createCommonjsModule(function (module) {
var eq = interopDefault(require$$3$1);

/**
 * Gets the index at which the `key` is found in `array` of key-value pairs.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {*} key The key to search for.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function assocIndexOf(array, key) {
  var length = array.length;
  while (length--) {
    if (eq(array[length][0], key)) {
      return length;
    }
  }
  return -1;
}

module.exports = assocIndexOf;
});

var _assocIndexOf$1 = interopDefault(_assocIndexOf);


var require$$0 = Object.freeze({
	default: _assocIndexOf$1
});

var _listCacheDelete = createCommonjsModule(function (module) {
var assocIndexOf = interopDefault(require$$0);

/** Used for built-in method references. */
var arrayProto = Array.prototype;

/** Built-in value references. */
var splice = arrayProto.splice;

/**
 * Removes `key` and its value from the list cache.
 *
 * @private
 * @name delete
 * @memberOf ListCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function listCacheDelete(key) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  if (index < 0) {
    return false;
  }
  var lastIndex = data.length - 1;
  if (index == lastIndex) {
    data.pop();
  } else {
    splice.call(data, index, 1);
  }
  --this.size;
  return true;
}

module.exports = listCacheDelete;
});

var _listCacheDelete$1 = interopDefault(_listCacheDelete);


var require$$3 = Object.freeze({
	default: _listCacheDelete$1
});

var _listCacheGet = createCommonjsModule(function (module) {
var assocIndexOf = interopDefault(require$$0);

/**
 * Gets the list cache value for `key`.
 *
 * @private
 * @name get
 * @memberOf ListCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function listCacheGet(key) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  return index < 0 ? undefined : data[index][1];
}

module.exports = listCacheGet;
});

var _listCacheGet$1 = interopDefault(_listCacheGet);


var require$$2$1 = Object.freeze({
	default: _listCacheGet$1
});

var _listCacheHas = createCommonjsModule(function (module) {
var assocIndexOf = interopDefault(require$$0);

/**
 * Checks if a list cache value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf ListCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function listCacheHas(key) {
  return assocIndexOf(this.__data__, key) > -1;
}

module.exports = listCacheHas;
});

var _listCacheHas$1 = interopDefault(_listCacheHas);


var require$$1$1 = Object.freeze({
	default: _listCacheHas$1
});

var _listCacheSet = createCommonjsModule(function (module) {
var assocIndexOf = interopDefault(require$$0);

/**
 * Sets the list cache `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf ListCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the list cache instance.
 */
function listCacheSet(key, value) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  if (index < 0) {
    ++this.size;
    data.push([key, value]);
  } else {
    data[index][1] = value;
  }
  return this;
}

module.exports = listCacheSet;
});

var _listCacheSet$1 = interopDefault(_listCacheSet);


var require$$0$1 = Object.freeze({
	default: _listCacheSet$1
});

var _ListCache = createCommonjsModule(function (module) {
var listCacheClear = interopDefault(require$$4$1),
    listCacheDelete = interopDefault(require$$3),
    listCacheGet = interopDefault(require$$2$1),
    listCacheHas = interopDefault(require$$1$1),
    listCacheSet = interopDefault(require$$0$1);

/**
 * Creates an list cache object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function ListCache(entries) {
  var index = -1,
      length = entries ? entries.length : 0;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

// Add methods to `ListCache`.
ListCache.prototype.clear = listCacheClear;
ListCache.prototype['delete'] = listCacheDelete;
ListCache.prototype.get = listCacheGet;
ListCache.prototype.has = listCacheHas;
ListCache.prototype.set = listCacheSet;

module.exports = ListCache;
});

var _ListCache$1 = interopDefault(_ListCache);


var require$$1 = Object.freeze({
	default: _ListCache$1
});

var _stackClear = createCommonjsModule(function (module) {
var ListCache = interopDefault(require$$1);

/**
 * Removes all key-value entries from the stack.
 *
 * @private
 * @name clear
 * @memberOf Stack
 */
function stackClear() {
  this.__data__ = new ListCache;
  this.size = 0;
}

module.exports = stackClear;
});

var _stackClear$1 = interopDefault(_stackClear);


var require$$4$2 = Object.freeze({
	default: _stackClear$1
});

var _stackDelete = createCommonjsModule(function (module) {
/**
 * Removes `key` and its value from the stack.
 *
 * @private
 * @name delete
 * @memberOf Stack
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function stackDelete(key) {
  var data = this.__data__,
      result = data['delete'](key);

  this.size = data.size;
  return result;
}

module.exports = stackDelete;
});

var _stackDelete$1 = interopDefault(_stackDelete);


var require$$3$2 = Object.freeze({
	default: _stackDelete$1
});

var _stackGet = createCommonjsModule(function (module) {
/**
 * Gets the stack value for `key`.
 *
 * @private
 * @name get
 * @memberOf Stack
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function stackGet(key) {
  return this.__data__.get(key);
}

module.exports = stackGet;
});

var _stackGet$1 = interopDefault(_stackGet);


var require$$2$2 = Object.freeze({
	default: _stackGet$1
});

var _stackHas = createCommonjsModule(function (module) {
/**
 * Checks if a stack value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Stack
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function stackHas(key) {
  return this.__data__.has(key);
}

module.exports = stackHas;
});

var _stackHas$1 = interopDefault(_stackHas);


var require$$1$2 = Object.freeze({
	default: _stackHas$1
});

var isObject = createCommonjsModule(function (module) {
/**
 * Checks if `value` is the
 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
 * @example
 *
 * _.isObject({});
 * // => true
 *
 * _.isObject([1, 2, 3]);
 * // => true
 *
 * _.isObject(_.noop);
 * // => true
 *
 * _.isObject(null);
 * // => false
 */
function isObject(value) {
  var type = typeof value;
  return value != null && (type == 'object' || type == 'function');
}

module.exports = isObject;
});

var isObject$1 = interopDefault(isObject);


var require$$0$4 = Object.freeze({
	default: isObject$1
});

var isFunction = createCommonjsModule(function (module) {
var isObject = interopDefault(require$$0$4);

/** `Object#toString` result references. */
var funcTag = '[object Function]',
    genTag = '[object GeneratorFunction]',
    proxyTag = '[object Proxy]';

/** Used for built-in method references. */
var objectProto = Object.prototype;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var objectToString = objectProto.toString;

/**
 * Checks if `value` is classified as a `Function` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a function, else `false`.
 * @example
 *
 * _.isFunction(_);
 * // => true
 *
 * _.isFunction(/abc/);
 * // => false
 */
function isFunction(value) {
  // The use of `Object#toString` avoids issues with the `typeof` operator
  // in Safari 8-9 which returns 'object' for typed array and other constructors.
  var tag = isObject(value) ? objectToString.call(value) : '';
  return tag == funcTag || tag == genTag || tag == proxyTag;
}

module.exports = isFunction;
});

var isFunction$1 = interopDefault(isFunction);


var require$$1$4 = Object.freeze({
	default: isFunction$1
});

var _freeGlobal = createCommonjsModule(function (module) {
/** Detect free variable `global` from Node.js. */
var freeGlobal = typeof commonjsGlobal == 'object' && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;

module.exports = freeGlobal;
});

var _freeGlobal$1 = interopDefault(_freeGlobal);


var require$$0$6 = Object.freeze({
	default: _freeGlobal$1
});

var _root = createCommonjsModule(function (module) {
var freeGlobal = interopDefault(require$$0$6);

/** Detect free variable `self`. */
var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

/** Used as a reference to the global object. */
var root = freeGlobal || freeSelf || Function('return this')();

module.exports = root;
});

var _root$1 = interopDefault(_root);


var require$$1$5 = Object.freeze({
	default: _root$1
});

var _coreJsData = createCommonjsModule(function (module) {
var root = interopDefault(require$$1$5);

/** Used to detect overreaching core-js shims. */
var coreJsData = root['__core-js_shared__'];

module.exports = coreJsData;
});

var _coreJsData$1 = interopDefault(_coreJsData);


var require$$0$5 = Object.freeze({
	default: _coreJsData$1
});

var _isMasked = createCommonjsModule(function (module) {
var coreJsData = interopDefault(require$$0$5);

/** Used to detect methods masquerading as native. */
var maskSrcKey = (function() {
  var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || '');
  return uid ? ('Symbol(src)_1.' + uid) : '';
}());

/**
 * Checks if `func` has its source masked.
 *
 * @private
 * @param {Function} func The function to check.
 * @returns {boolean} Returns `true` if `func` is masked, else `false`.
 */
function isMasked(func) {
  return !!maskSrcKey && (maskSrcKey in func);
}

module.exports = isMasked;
});

var _isMasked$1 = interopDefault(_isMasked);


var require$$2$3 = Object.freeze({
	default: _isMasked$1
});

var _toSource = createCommonjsModule(function (module) {
/** Used for built-in method references. */
var funcProto = Function.prototype;

/** Used to resolve the decompiled source of functions. */
var funcToString = funcProto.toString;

/**
 * Converts `func` to its source code.
 *
 * @private
 * @param {Function} func The function to process.
 * @returns {string} Returns the source code.
 */
function toSource(func) {
  if (func != null) {
    try {
      return funcToString.call(func);
    } catch (e) {}
    try {
      return (func + '');
    } catch (e) {}
  }
  return '';
}

module.exports = toSource;
});

var _toSource$1 = interopDefault(_toSource);


var require$$0$7 = Object.freeze({
	default: _toSource$1
});

var _baseIsNative = createCommonjsModule(function (module) {
var isFunction = interopDefault(require$$1$4),
    isMasked = interopDefault(require$$2$3),
    isObject = interopDefault(require$$0$4),
    toSource = interopDefault(require$$0$7);

/**
 * Used to match `RegExp`
 * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
 */
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;

/** Used to detect host constructors (Safari). */
var reIsHostCtor = /^\[object .+?Constructor\]$/;

/** Used for built-in method references. */
var funcProto = Function.prototype,
    objectProto = Object.prototype;

/** Used to resolve the decompiled source of functions. */
var funcToString = funcProto.toString;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/** Used to detect if a method is native. */
var reIsNative = RegExp('^' +
  funcToString.call(hasOwnProperty).replace(reRegExpChar, '\\$&')
  .replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$'
);

/**
 * The base implementation of `_.isNative` without bad shim checks.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a native function,
 *  else `false`.
 */
function baseIsNative(value) {
  if (!isObject(value) || isMasked(value)) {
    return false;
  }
  var pattern = isFunction(value) ? reIsNative : reIsHostCtor;
  return pattern.test(toSource(value));
}

module.exports = baseIsNative;
});

var _baseIsNative$1 = interopDefault(_baseIsNative);


var require$$1$3 = Object.freeze({
	default: _baseIsNative$1
});

var _getValue = createCommonjsModule(function (module) {
/**
 * Gets the value at `key` of `object`.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {string} key The key of the property to get.
 * @returns {*} Returns the property value.
 */
function getValue(object, key) {
  return object == null ? undefined : object[key];
}

module.exports = getValue;
});

var _getValue$1 = interopDefault(_getValue);


var require$$0$8 = Object.freeze({
	default: _getValue$1
});

var _getNative = createCommonjsModule(function (module) {
var baseIsNative = interopDefault(require$$1$3),
    getValue = interopDefault(require$$0$8);

/**
 * Gets the native function at `key` of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {string} key The key of the method to get.
 * @returns {*} Returns the function if it's native, else `undefined`.
 */
function getNative(object, key) {
  var value = getValue(object, key);
  return baseIsNative(value) ? value : undefined;
}

module.exports = getNative;
});

var _getNative$1 = interopDefault(_getNative);


var require$$0$3 = Object.freeze({
	default: _getNative$1
});

var _Map = createCommonjsModule(function (module) {
var getNative = interopDefault(require$$0$3),
    root = interopDefault(require$$1$5);

/* Built-in method references that are verified to be native. */
var Map = getNative(root, 'Map');

module.exports = Map;
});

var _Map$1 = interopDefault(_Map);


var require$$5$1 = Object.freeze({
	default: _Map$1
});

var _nativeCreate = createCommonjsModule(function (module) {
var getNative = interopDefault(require$$0$3);

/* Built-in method references that are verified to be native. */
var nativeCreate = getNative(Object, 'create');

module.exports = nativeCreate;
});

var _nativeCreate$1 = interopDefault(_nativeCreate);


var require$$0$10 = Object.freeze({
	default: _nativeCreate$1
});

var _hashClear = createCommonjsModule(function (module) {
var nativeCreate = interopDefault(require$$0$10);

/**
 * Removes all key-value entries from the hash.
 *
 * @private
 * @name clear
 * @memberOf Hash
 */
function hashClear() {
  this.__data__ = nativeCreate ? nativeCreate(null) : {};
  this.size = 0;
}

module.exports = hashClear;
});

var _hashClear$1 = interopDefault(_hashClear);


var require$$4$4 = Object.freeze({
	default: _hashClear$1
});

var _hashDelete = createCommonjsModule(function (module) {
/**
 * Removes `key` and its value from the hash.
 *
 * @private
 * @name delete
 * @memberOf Hash
 * @param {Object} hash The hash to modify.
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function hashDelete(key) {
  var result = this.has(key) && delete this.__data__[key];
  this.size -= result ? 1 : 0;
  return result;
}

module.exports = hashDelete;
});

var _hashDelete$1 = interopDefault(_hashDelete);


var require$$3$3 = Object.freeze({
	default: _hashDelete$1
});

var _hashGet = createCommonjsModule(function (module) {
var nativeCreate = interopDefault(require$$0$10);

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED = '__lodash_hash_undefined__';

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Gets the hash value for `key`.
 *
 * @private
 * @name get
 * @memberOf Hash
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function hashGet(key) {
  var data = this.__data__;
  if (nativeCreate) {
    var result = data[key];
    return result === HASH_UNDEFINED ? undefined : result;
  }
  return hasOwnProperty.call(data, key) ? data[key] : undefined;
}

module.exports = hashGet;
});

var _hashGet$1 = interopDefault(_hashGet);


var require$$2$5 = Object.freeze({
	default: _hashGet$1
});

var _hashHas = createCommonjsModule(function (module) {
var nativeCreate = interopDefault(require$$0$10);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Checks if a hash value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Hash
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function hashHas(key) {
  var data = this.__data__;
  return nativeCreate ? data[key] !== undefined : hasOwnProperty.call(data, key);
}

module.exports = hashHas;
});

var _hashHas$1 = interopDefault(_hashHas);


var require$$1$6 = Object.freeze({
	default: _hashHas$1
});

var _hashSet = createCommonjsModule(function (module) {
var nativeCreate = interopDefault(require$$0$10);

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED = '__lodash_hash_undefined__';

/**
 * Sets the hash `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Hash
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the hash instance.
 */
function hashSet(key, value) {
  var data = this.__data__;
  this.size += this.has(key) ? 0 : 1;
  data[key] = (nativeCreate && value === undefined) ? HASH_UNDEFINED : value;
  return this;
}

module.exports = hashSet;
});

var _hashSet$1 = interopDefault(_hashSet);


var require$$0$11 = Object.freeze({
	default: _hashSet$1
});

var _Hash = createCommonjsModule(function (module) {
var hashClear = interopDefault(require$$4$4),
    hashDelete = interopDefault(require$$3$3),
    hashGet = interopDefault(require$$2$5),
    hashHas = interopDefault(require$$1$6),
    hashSet = interopDefault(require$$0$11);

/**
 * Creates a hash object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function Hash(entries) {
  var index = -1,
      length = entries ? entries.length : 0;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

// Add methods to `Hash`.
Hash.prototype.clear = hashClear;
Hash.prototype['delete'] = hashDelete;
Hash.prototype.get = hashGet;
Hash.prototype.has = hashHas;
Hash.prototype.set = hashSet;

module.exports = Hash;
});

var _Hash$1 = interopDefault(_Hash);


var require$$2$4 = Object.freeze({
	default: _Hash$1
});

var _mapCacheClear = createCommonjsModule(function (module) {
var Hash = interopDefault(require$$2$4),
    ListCache = interopDefault(require$$1),
    Map = interopDefault(require$$5$1);

/**
 * Removes all key-value entries from the map.
 *
 * @private
 * @name clear
 * @memberOf MapCache
 */
function mapCacheClear() {
  this.size = 0;
  this.__data__ = {
    'hash': new Hash,
    'map': new (Map || ListCache),
    'string': new Hash
  };
}

module.exports = mapCacheClear;
});

var _mapCacheClear$1 = interopDefault(_mapCacheClear);


var require$$4$3 = Object.freeze({
	default: _mapCacheClear$1
});

var _isKeyable = createCommonjsModule(function (module) {
/**
 * Checks if `value` is suitable for use as unique object key.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
 */
function isKeyable(value) {
  var type = typeof value;
  return (type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean')
    ? (value !== '__proto__')
    : (value === null);
}

module.exports = isKeyable;
});

var _isKeyable$1 = interopDefault(_isKeyable);


var require$$0$13 = Object.freeze({
	default: _isKeyable$1
});

var _getMapData = createCommonjsModule(function (module) {
var isKeyable = interopDefault(require$$0$13);

/**
 * Gets the data for `map`.
 *
 * @private
 * @param {Object} map The map to query.
 * @param {string} key The reference key.
 * @returns {*} Returns the map data.
 */
function getMapData(map, key) {
  var data = map.__data__;
  return isKeyable(key)
    ? data[typeof key == 'string' ? 'string' : 'hash']
    : data.map;
}

module.exports = getMapData;
});

var _getMapData$1 = interopDefault(_getMapData);


var require$$0$12 = Object.freeze({
	default: _getMapData$1
});

var _mapCacheDelete = createCommonjsModule(function (module) {
var getMapData = interopDefault(require$$0$12);

/**
 * Removes `key` and its value from the map.
 *
 * @private
 * @name delete
 * @memberOf MapCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function mapCacheDelete(key) {
  var result = getMapData(this, key)['delete'](key);
  this.size -= result ? 1 : 0;
  return result;
}

module.exports = mapCacheDelete;
});

var _mapCacheDelete$1 = interopDefault(_mapCacheDelete);


var require$$3$4 = Object.freeze({
	default: _mapCacheDelete$1
});

var _mapCacheGet = createCommonjsModule(function (module) {
var getMapData = interopDefault(require$$0$12);

/**
 * Gets the map value for `key`.
 *
 * @private
 * @name get
 * @memberOf MapCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function mapCacheGet(key) {
  return getMapData(this, key).get(key);
}

module.exports = mapCacheGet;
});

var _mapCacheGet$1 = interopDefault(_mapCacheGet);


var require$$2$6 = Object.freeze({
	default: _mapCacheGet$1
});

var _mapCacheHas = createCommonjsModule(function (module) {
var getMapData = interopDefault(require$$0$12);

/**
 * Checks if a map value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf MapCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function mapCacheHas(key) {
  return getMapData(this, key).has(key);
}

module.exports = mapCacheHas;
});

var _mapCacheHas$1 = interopDefault(_mapCacheHas);


var require$$1$7 = Object.freeze({
	default: _mapCacheHas$1
});

var _mapCacheSet = createCommonjsModule(function (module) {
var getMapData = interopDefault(require$$0$12);

/**
 * Sets the map `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf MapCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the map cache instance.
 */
function mapCacheSet(key, value) {
  var data = getMapData(this, key),
      size = data.size;

  data.set(key, value);
  this.size += data.size == size ? 0 : 1;
  return this;
}

module.exports = mapCacheSet;
});

var _mapCacheSet$1 = interopDefault(_mapCacheSet);


var require$$0$14 = Object.freeze({
	default: _mapCacheSet$1
});

var _MapCache = createCommonjsModule(function (module) {
var mapCacheClear = interopDefault(require$$4$3),
    mapCacheDelete = interopDefault(require$$3$4),
    mapCacheGet = interopDefault(require$$2$6),
    mapCacheHas = interopDefault(require$$1$7),
    mapCacheSet = interopDefault(require$$0$14);

/**
 * Creates a map cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function MapCache(entries) {
  var index = -1,
      length = entries ? entries.length : 0;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

// Add methods to `MapCache`.
MapCache.prototype.clear = mapCacheClear;
MapCache.prototype['delete'] = mapCacheDelete;
MapCache.prototype.get = mapCacheGet;
MapCache.prototype.has = mapCacheHas;
MapCache.prototype.set = mapCacheSet;

module.exports = MapCache;
});

var _MapCache$1 = interopDefault(_MapCache);


var require$$0$9 = Object.freeze({
	default: _MapCache$1
});

var _stackSet = createCommonjsModule(function (module) {
var ListCache = interopDefault(require$$1),
    Map = interopDefault(require$$5$1),
    MapCache = interopDefault(require$$0$9);

/** Used as the size to enable large array optimizations. */
var LARGE_ARRAY_SIZE = 200;

/**
 * Sets the stack `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Stack
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the stack cache instance.
 */
function stackSet(key, value) {
  var data = this.__data__;
  if (data instanceof ListCache) {
    var pairs = data.__data__;
    if (!Map || (pairs.length < LARGE_ARRAY_SIZE - 1)) {
      pairs.push([key, value]);
      this.size = ++data.size;
      return this;
    }
    data = this.__data__ = new MapCache(pairs);
  }
  data.set(key, value);
  this.size = data.size;
  return this;
}

module.exports = stackSet;
});

var _stackSet$1 = interopDefault(_stackSet);


var require$$0$2 = Object.freeze({
	default: _stackSet$1
});

var _Stack = createCommonjsModule(function (module) {
var ListCache = interopDefault(require$$1),
    stackClear = interopDefault(require$$4$2),
    stackDelete = interopDefault(require$$3$2),
    stackGet = interopDefault(require$$2$2),
    stackHas = interopDefault(require$$1$2),
    stackSet = interopDefault(require$$0$2);

/**
 * Creates a stack cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function Stack(entries) {
  var data = this.__data__ = new ListCache(entries);
  this.size = data.size;
}

// Add methods to `Stack`.
Stack.prototype.clear = stackClear;
Stack.prototype['delete'] = stackDelete;
Stack.prototype.get = stackGet;
Stack.prototype.has = stackHas;
Stack.prototype.set = stackSet;

module.exports = Stack;
});

var _Stack$1 = interopDefault(_Stack);


var require$$7 = Object.freeze({
	default: _Stack$1
});

var _setCacheAdd = createCommonjsModule(function (module) {
/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED = '__lodash_hash_undefined__';

/**
 * Adds `value` to the array cache.
 *
 * @private
 * @name add
 * @memberOf SetCache
 * @alias push
 * @param {*} value The value to cache.
 * @returns {Object} Returns the cache instance.
 */
function setCacheAdd(value) {
  this.__data__.set(value, HASH_UNDEFINED);
  return this;
}

module.exports = setCacheAdd;
});

var _setCacheAdd$1 = interopDefault(_setCacheAdd);


var require$$1$8 = Object.freeze({
	default: _setCacheAdd$1
});

var _setCacheHas = createCommonjsModule(function (module) {
/**
 * Checks if `value` is in the array cache.
 *
 * @private
 * @name has
 * @memberOf SetCache
 * @param {*} value The value to search for.
 * @returns {number} Returns `true` if `value` is found, else `false`.
 */
function setCacheHas(value) {
  return this.__data__.has(value);
}

module.exports = setCacheHas;
});

var _setCacheHas$1 = interopDefault(_setCacheHas);


var require$$0$15 = Object.freeze({
	default: _setCacheHas$1
});

var _SetCache = createCommonjsModule(function (module) {
var MapCache = interopDefault(require$$0$9),
    setCacheAdd = interopDefault(require$$1$8),
    setCacheHas = interopDefault(require$$0$15);

/**
 *
 * Creates an array cache object to store unique values.
 *
 * @private
 * @constructor
 * @param {Array} [values] The values to cache.
 */
function SetCache(values) {
  var index = -1,
      length = values ? values.length : 0;

  this.__data__ = new MapCache;
  while (++index < length) {
    this.add(values[index]);
  }
}

// Add methods to `SetCache`.
SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
SetCache.prototype.has = setCacheHas;

module.exports = SetCache;
});

var _SetCache$1 = interopDefault(_SetCache);


var require$$2$9 = Object.freeze({
	default: _SetCache$1
});

var _arraySome = createCommonjsModule(function (module) {
/**
 * A specialized version of `_.some` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {boolean} Returns `true` if any element passes the predicate check,
 *  else `false`.
 */
function arraySome(array, predicate) {
  var index = -1,
      length = array ? array.length : 0;

  while (++index < length) {
    if (predicate(array[index], index, array)) {
      return true;
    }
  }
  return false;
}

module.exports = arraySome;
});

var _arraySome$1 = interopDefault(_arraySome);


var require$$1$9 = Object.freeze({
	default: _arraySome$1
});

var _cacheHas = createCommonjsModule(function (module) {
/**
 * Checks if a `cache` value for `key` exists.
 *
 * @private
 * @param {Object} cache The cache to query.
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function cacheHas(cache, key) {
  return cache.has(key);
}

module.exports = cacheHas;
});

var _cacheHas$1 = interopDefault(_cacheHas);


var require$$0$16 = Object.freeze({
	default: _cacheHas$1
});

var _equalArrays = createCommonjsModule(function (module) {
var SetCache = interopDefault(require$$2$9),
    arraySome = interopDefault(require$$1$9),
    cacheHas = interopDefault(require$$0$16);

/** Used to compose bitmasks for comparison styles. */
var UNORDERED_COMPARE_FLAG = 1,
    PARTIAL_COMPARE_FLAG = 2;

/**
 * A specialized version of `baseIsEqualDeep` for arrays with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Array} array The array to compare.
 * @param {Array} other The other array to compare.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Function} customizer The function to customize comparisons.
 * @param {number} bitmask The bitmask of comparison flags. See `baseIsEqual`
 *  for more details.
 * @param {Object} stack Tracks traversed `array` and `other` objects.
 * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.
 */
function equalArrays(array, other, equalFunc, customizer, bitmask, stack) {
  var isPartial = bitmask & PARTIAL_COMPARE_FLAG,
      arrLength = array.length,
      othLength = other.length;

  if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
    return false;
  }
  // Assume cyclic values are equal.
  var stacked = stack.get(array);
  if (stacked && stack.get(other)) {
    return stacked == other;
  }
  var index = -1,
      result = true,
      seen = (bitmask & UNORDERED_COMPARE_FLAG) ? new SetCache : undefined;

  stack.set(array, other);
  stack.set(other, array);

  // Ignore non-index properties.
  while (++index < arrLength) {
    var arrValue = array[index],
        othValue = other[index];

    if (customizer) {
      var compared = isPartial
        ? customizer(othValue, arrValue, index, other, array, stack)
        : customizer(arrValue, othValue, index, array, other, stack);
    }
    if (compared !== undefined) {
      if (compared) {
        continue;
      }
      result = false;
      break;
    }
    // Recursively compare arrays (susceptible to call stack limits).
    if (seen) {
      if (!arraySome(other, function(othValue, othIndex) {
            if (!cacheHas(seen, othIndex) &&
                (arrValue === othValue || equalFunc(arrValue, othValue, customizer, bitmask, stack))) {
              return seen.push(othIndex);
            }
          })) {
        result = false;
        break;
      }
    } else if (!(
          arrValue === othValue ||
            equalFunc(arrValue, othValue, customizer, bitmask, stack)
        )) {
      result = false;
      break;
    }
  }
  stack['delete'](array);
  stack['delete'](other);
  return result;
}

module.exports = equalArrays;
});

var _equalArrays$1 = interopDefault(_equalArrays);


var require$$2$8 = Object.freeze({
	default: _equalArrays$1
});

var _Symbol = createCommonjsModule(function (module) {
var root = interopDefault(require$$1$5);

/** Built-in value references. */
var Symbol = root.Symbol;

module.exports = Symbol;
});

var _Symbol$1 = interopDefault(_Symbol);


var require$$2$10 = Object.freeze({
	default: _Symbol$1
});

var _Uint8Array = createCommonjsModule(function (module) {
var root = interopDefault(require$$1$5);

/** Built-in value references. */
var Uint8Array = root.Uint8Array;

module.exports = Uint8Array;
});

var _Uint8Array$1 = interopDefault(_Uint8Array);


var require$$4$5 = Object.freeze({
	default: _Uint8Array$1
});

var _mapToArray = createCommonjsModule(function (module) {
/**
 * Converts `map` to its key-value pairs.
 *
 * @private
 * @param {Object} map The map to convert.
 * @returns {Array} Returns the key-value pairs.
 */
function mapToArray(map) {
  var index = -1,
      result = Array(map.size);

  map.forEach(function(value, key) {
    result[++index] = [key, value];
  });
  return result;
}

module.exports = mapToArray;
});

var _mapToArray$1 = interopDefault(_mapToArray);


var require$$1$10 = Object.freeze({
	default: _mapToArray$1
});

var _setToArray = createCommonjsModule(function (module) {
/**
 * Converts `set` to an array of its values.
 *
 * @private
 * @param {Object} set The set to convert.
 * @returns {Array} Returns the values.
 */
function setToArray(set) {
  var index = -1,
      result = Array(set.size);

  set.forEach(function(value) {
    result[++index] = value;
  });
  return result;
}

module.exports = setToArray;
});

var _setToArray$1 = interopDefault(_setToArray);


var require$$0$17 = Object.freeze({
	default: _setToArray$1
});

var _equalByTag = createCommonjsModule(function (module) {
var Symbol = interopDefault(require$$2$10),
    Uint8Array = interopDefault(require$$4$5),
    eq = interopDefault(require$$3$1),
    equalArrays = interopDefault(require$$2$8),
    mapToArray = interopDefault(require$$1$10),
    setToArray = interopDefault(require$$0$17);

/** Used to compose bitmasks for comparison styles. */
var UNORDERED_COMPARE_FLAG = 1,
    PARTIAL_COMPARE_FLAG = 2;

/** `Object#toString` result references. */
var boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    symbolTag = '[object Symbol]';

var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]';

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol ? Symbol.prototype : undefined,
    symbolValueOf = symbolProto ? symbolProto.valueOf : undefined;

/**
 * A specialized version of `baseIsEqualDeep` for comparing objects of
 * the same `toStringTag`.
 *
 * **Note:** This function only supports comparing values with tags of
 * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {string} tag The `toStringTag` of the objects to compare.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Function} customizer The function to customize comparisons.
 * @param {number} bitmask The bitmask of comparison flags. See `baseIsEqual`
 *  for more details.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function equalByTag(object, other, tag, equalFunc, customizer, bitmask, stack) {
  switch (tag) {
    case dataViewTag:
      if ((object.byteLength != other.byteLength) ||
          (object.byteOffset != other.byteOffset)) {
        return false;
      }
      object = object.buffer;
      other = other.buffer;

    case arrayBufferTag:
      if ((object.byteLength != other.byteLength) ||
          !equalFunc(new Uint8Array(object), new Uint8Array(other))) {
        return false;
      }
      return true;

    case boolTag:
    case dateTag:
    case numberTag:
      // Coerce booleans to `1` or `0` and dates to milliseconds.
      // Invalid dates are coerced to `NaN`.
      return eq(+object, +other);

    case errorTag:
      return object.name == other.name && object.message == other.message;

    case regexpTag:
    case stringTag:
      // Coerce regexes to strings and treat strings, primitives and objects,
      // as equal. See http://www.ecma-international.org/ecma-262/7.0/#sec-regexp.prototype.tostring
      // for more details.
      return object == (other + '');

    case mapTag:
      var convert = mapToArray;

    case setTag:
      var isPartial = bitmask & PARTIAL_COMPARE_FLAG;
      convert || (convert = setToArray);

      if (object.size != other.size && !isPartial) {
        return false;
      }
      // Assume cyclic values are equal.
      var stacked = stack.get(object);
      if (stacked) {
        return stacked == other;
      }
      bitmask |= UNORDERED_COMPARE_FLAG;

      // Recursively compare objects (susceptible to call stack limits).
      stack.set(object, other);
      var result = equalArrays(convert(object), convert(other), equalFunc, customizer, bitmask, stack);
      stack['delete'](object);
      return result;

    case symbolTag:
      if (symbolValueOf) {
        return symbolValueOf.call(object) == symbolValueOf.call(other);
      }
  }
  return false;
}

module.exports = equalByTag;
});

var _equalByTag$1 = interopDefault(_equalByTag);


var require$$5$2 = Object.freeze({
	default: _equalByTag$1
});

var _baseTimes = createCommonjsModule(function (module) {
/**
 * The base implementation of `_.times` without support for iteratee shorthands
 * or max array length checks.
 *
 * @private
 * @param {number} n The number of times to invoke `iteratee`.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the array of results.
 */
function baseTimes(n, iteratee) {
  var index = -1,
      result = Array(n);

  while (++index < n) {
    result[index] = iteratee(index);
  }
  return result;
}

module.exports = baseTimes;
});

var _baseTimes$1 = interopDefault(_baseTimes);


var require$$3$5 = Object.freeze({
	default: _baseTimes$1
});

var isLength = createCommonjsModule(function (module) {
/** Used as references for various `Number` constants. */
var MAX_SAFE_INTEGER = 9007199254740991;

/**
 * Checks if `value` is a valid array-like length.
 *
 * **Note:** This method is loosely based on
 * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
 * @example
 *
 * _.isLength(3);
 * // => true
 *
 * _.isLength(Number.MIN_VALUE);
 * // => false
 *
 * _.isLength(Infinity);
 * // => false
 *
 * _.isLength('3');
 * // => false
 */
function isLength(value) {
  return typeof value == 'number' &&
    value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
}

module.exports = isLength;
});

var isLength$1 = interopDefault(isLength);


var require$$1$12 = Object.freeze({
	default: isLength$1
});

var isArrayLike = createCommonjsModule(function (module) {
var isFunction = interopDefault(require$$1$4),
    isLength = interopDefault(require$$1$12);

/**
 * Checks if `value` is array-like. A value is considered array-like if it's
 * not a function and has a `value.length` that's an integer greater than or
 * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
 * @example
 *
 * _.isArrayLike([1, 2, 3]);
 * // => true
 *
 * _.isArrayLike(document.body.children);
 * // => true
 *
 * _.isArrayLike('abc');
 * // => true
 *
 * _.isArrayLike(_.noop);
 * // => false
 */
function isArrayLike(value) {
  return value != null && isLength(value.length) && !isFunction(value);
}

module.exports = isArrayLike;
});

var isArrayLike$1 = interopDefault(isArrayLike);


var require$$2$12 = Object.freeze({
	default: isArrayLike$1
});

var isObjectLike = createCommonjsModule(function (module) {
/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */
function isObjectLike(value) {
  return value != null && typeof value == 'object';
}

module.exports = isObjectLike;
});

var isObjectLike$1 = interopDefault(isObjectLike);


var require$$0$20 = Object.freeze({
	default: isObjectLike$1
});

var isArrayLikeObject = createCommonjsModule(function (module) {
var isArrayLike = interopDefault(require$$2$12),
    isObjectLike = interopDefault(require$$0$20);

/**
 * This method is like `_.isArrayLike` except that it also checks if `value`
 * is an object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array-like object,
 *  else `false`.
 * @example
 *
 * _.isArrayLikeObject([1, 2, 3]);
 * // => true
 *
 * _.isArrayLikeObject(document.body.children);
 * // => true
 *
 * _.isArrayLikeObject('abc');
 * // => false
 *
 * _.isArrayLikeObject(_.noop);
 * // => false
 */
function isArrayLikeObject(value) {
  return isObjectLike(value) && isArrayLike(value);
}

module.exports = isArrayLikeObject;
});

var isArrayLikeObject$1 = interopDefault(isArrayLikeObject);


var require$$0$19 = Object.freeze({
	default: isArrayLikeObject$1
});

var isArguments = createCommonjsModule(function (module) {
var isArrayLikeObject = interopDefault(require$$0$19);

/** `Object#toString` result references. */
var argsTag = '[object Arguments]';

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var objectToString = objectProto.toString;

/** Built-in value references. */
var propertyIsEnumerable = objectProto.propertyIsEnumerable;

/**
 * Checks if `value` is likely an `arguments` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 *  else `false`.
 * @example
 *
 * _.isArguments(function() { return arguments; }());
 * // => true
 *
 * _.isArguments([1, 2, 3]);
 * // => false
 */
function isArguments(value) {
  // Safari 8.1 makes `arguments.callee` enumerable in strict mode.
  return isArrayLikeObject(value) && hasOwnProperty.call(value, 'callee') &&
    (!propertyIsEnumerable.call(value, 'callee') || objectToString.call(value) == argsTag);
}

module.exports = isArguments;
});

var isArguments$1 = interopDefault(isArguments);


var require$$1$11 = Object.freeze({
	default: isArguments$1
});

var isArray = createCommonjsModule(function (module) {
/**
 * Checks if `value` is classified as an `Array` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array, else `false`.
 * @example
 *
 * _.isArray([1, 2, 3]);
 * // => true
 *
 * _.isArray(document.body.children);
 * // => false
 *
 * _.isArray('abc');
 * // => false
 *
 * _.isArray(_.noop);
 * // => false
 */
var isArray = Array.isArray;

module.exports = isArray;
});

var isArray$1 = interopDefault(isArray);


var require$$0$21 = Object.freeze({
	default: isArray$1
});

var _isIndex = createCommonjsModule(function (module) {
/** Used as references for various `Number` constants. */
var MAX_SAFE_INTEGER = 9007199254740991;

/** Used to detect unsigned integer values. */
var reIsUint = /^(?:0|[1-9]\d*)$/;

/**
 * Checks if `value` is a valid array-like index.
 *
 * @private
 * @param {*} value The value to check.
 * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
 * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
 */
function isIndex(value, length) {
  length = length == null ? MAX_SAFE_INTEGER : length;
  return !!length &&
    (typeof value == 'number' || reIsUint.test(value)) &&
    (value > -1 && value % 1 == 0 && value < length);
}

module.exports = isIndex;
});

var _isIndex$1 = interopDefault(_isIndex);


var require$$1$13 = Object.freeze({
	default: _isIndex$1
});

var _arrayLikeKeys = createCommonjsModule(function (module) {
var baseTimes = interopDefault(require$$3$5),
    isArguments = interopDefault(require$$1$11),
    isArray = interopDefault(require$$0$21),
    isIndex = interopDefault(require$$1$13);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Creates an array of the enumerable property names of the array-like `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @param {boolean} inherited Specify returning inherited property names.
 * @returns {Array} Returns the array of property names.
 */
function arrayLikeKeys(value, inherited) {
  // Safari 8.1 makes `arguments.callee` enumerable in strict mode.
  // Safari 9 makes `arguments.length` enumerable in strict mode.
  var result = (isArray(value) || isArguments(value))
    ? baseTimes(value.length, String)
    : [];

  var length = result.length,
      skipIndexes = !!length;

  for (var key in value) {
    if ((inherited || hasOwnProperty.call(value, key)) &&
        !(skipIndexes && (key == 'length' || isIndex(key, length)))) {
      result.push(key);
    }
  }
  return result;
}

module.exports = arrayLikeKeys;
});

var _arrayLikeKeys$1 = interopDefault(_arrayLikeKeys);


var require$$2$11 = Object.freeze({
	default: _arrayLikeKeys$1
});

var _isPrototype = createCommonjsModule(function (module) {
/** Used for built-in method references. */
var objectProto = Object.prototype;

/**
 * Checks if `value` is likely a prototype object.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
 */
function isPrototype(value) {
  var Ctor = value && value.constructor,
      proto = (typeof Ctor == 'function' && Ctor.prototype) || objectProto;

  return value === proto;
}

module.exports = isPrototype;
});

var _isPrototype$1 = interopDefault(_isPrototype);


var require$$1$15 = Object.freeze({
	default: _isPrototype$1
});

var _overArg = createCommonjsModule(function (module) {
/**
 * Creates a unary function that invokes `func` with its argument transformed.
 *
 * @private
 * @param {Function} func The function to wrap.
 * @param {Function} transform The argument transform.
 * @returns {Function} Returns the new function.
 */
function overArg(func, transform) {
  return function(arg) {
    return func(transform(arg));
  };
}

module.exports = overArg;
});

var _overArg$1 = interopDefault(_overArg);


var require$$0$23 = Object.freeze({
	default: _overArg$1
});

var _nativeKeys = createCommonjsModule(function (module) {
var overArg = interopDefault(require$$0$23);

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeKeys = overArg(Object.keys, Object);

module.exports = nativeKeys;
});

var _nativeKeys$1 = interopDefault(_nativeKeys);


var require$$0$22 = Object.freeze({
	default: _nativeKeys$1
});

var _baseKeys = createCommonjsModule(function (module) {
var isPrototype = interopDefault(require$$1$15),
    nativeKeys = interopDefault(require$$0$22);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function baseKeys(object) {
  if (!isPrototype(object)) {
    return nativeKeys(object);
  }
  var result = [];
  for (var key in Object(object)) {
    if (hasOwnProperty.call(object, key) && key != 'constructor') {
      result.push(key);
    }
  }
  return result;
}

module.exports = baseKeys;
});

var _baseKeys$1 = interopDefault(_baseKeys);


var require$$1$14 = Object.freeze({
	default: _baseKeys$1
});

var keys = createCommonjsModule(function (module) {
var arrayLikeKeys = interopDefault(require$$2$11),
    baseKeys = interopDefault(require$$1$14),
    isArrayLike = interopDefault(require$$2$12);

/**
 * Creates an array of the own enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects. See the
 * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * for more details.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keys(new Foo);
 * // => ['a', 'b'] (iteration order is not guaranteed)
 *
 * _.keys('hi');
 * // => ['0', '1']
 */
function keys(object) {
  return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
}

module.exports = keys;
});

var keys$1 = interopDefault(keys);


var require$$0$18 = Object.freeze({
	default: keys$1
});

var _equalObjects = createCommonjsModule(function (module) {
var keys = interopDefault(require$$0$18);

/** Used to compose bitmasks for comparison styles. */
var PARTIAL_COMPARE_FLAG = 2;

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * A specialized version of `baseIsEqualDeep` for objects with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Function} customizer The function to customize comparisons.
 * @param {number} bitmask The bitmask of comparison flags. See `baseIsEqual`
 *  for more details.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function equalObjects(object, other, equalFunc, customizer, bitmask, stack) {
  var isPartial = bitmask & PARTIAL_COMPARE_FLAG,
      objProps = keys(object),
      objLength = objProps.length,
      othProps = keys(other),
      othLength = othProps.length;

  if (objLength != othLength && !isPartial) {
    return false;
  }
  var index = objLength;
  while (index--) {
    var key = objProps[index];
    if (!(isPartial ? key in other : hasOwnProperty.call(other, key))) {
      return false;
    }
  }
  // Assume cyclic values are equal.
  var stacked = stack.get(object);
  if (stacked && stack.get(other)) {
    return stacked == other;
  }
  var result = true;
  stack.set(object, other);
  stack.set(other, object);

  var skipCtor = isPartial;
  while (++index < objLength) {
    key = objProps[index];
    var objValue = object[key],
        othValue = other[key];

    if (customizer) {
      var compared = isPartial
        ? customizer(othValue, objValue, key, other, object, stack)
        : customizer(objValue, othValue, key, object, other, stack);
    }
    // Recursively compare objects (susceptible to call stack limits).
    if (!(compared === undefined
          ? (objValue === othValue || equalFunc(objValue, othValue, customizer, bitmask, stack))
          : compared
        )) {
      result = false;
      break;
    }
    skipCtor || (skipCtor = key == 'constructor');
  }
  if (result && !skipCtor) {
    var objCtor = object.constructor,
        othCtor = other.constructor;

    // Non `Object` object instances with different constructors are not equal.
    if (objCtor != othCtor &&
        ('constructor' in object && 'constructor' in other) &&
        !(typeof objCtor == 'function' && objCtor instanceof objCtor &&
          typeof othCtor == 'function' && othCtor instanceof othCtor)) {
      result = false;
    }
  }
  stack['delete'](object);
  stack['delete'](other);
  return result;
}

module.exports = equalObjects;
});

var _equalObjects$1 = interopDefault(_equalObjects);


var require$$4$6 = Object.freeze({
	default: _equalObjects$1
});

var _DataView = createCommonjsModule(function (module) {
var getNative = interopDefault(require$$0$3),
    root = interopDefault(require$$1$5);

/* Built-in method references that are verified to be native. */
var DataView = getNative(root, 'DataView');

module.exports = DataView;
});

var _DataView$1 = interopDefault(_DataView);


var require$$6$2 = Object.freeze({
	default: _DataView$1
});

var _Promise = createCommonjsModule(function (module) {
var getNative = interopDefault(require$$0$3),
    root = interopDefault(require$$1$5);

/* Built-in method references that are verified to be native. */
var Promise = getNative(root, 'Promise');

module.exports = Promise;
});

var _Promise$1 = interopDefault(_Promise);


var require$$4$7 = Object.freeze({
	default: _Promise$1
});

var _Set = createCommonjsModule(function (module) {
var getNative = interopDefault(require$$0$3),
    root = interopDefault(require$$1$5);

/* Built-in method references that are verified to be native. */
var Set = getNative(root, 'Set');

module.exports = Set;
});

var _Set$1 = interopDefault(_Set);


var require$$3$7 = Object.freeze({
	default: _Set$1
});

var _WeakMap = createCommonjsModule(function (module) {
var getNative = interopDefault(require$$0$3),
    root = interopDefault(require$$1$5);

/* Built-in method references that are verified to be native. */
var WeakMap = getNative(root, 'WeakMap');

module.exports = WeakMap;
});

var _WeakMap$1 = interopDefault(_WeakMap);


var require$$2$13 = Object.freeze({
	default: _WeakMap$1
});

var _baseGetTag = createCommonjsModule(function (module) {
/** Used for built-in method references. */
var objectProto = Object.prototype;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var objectToString = objectProto.toString;

/**
 * The base implementation of `getTag`.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */
function baseGetTag(value) {
  return objectToString.call(value);
}

module.exports = baseGetTag;
});

var _baseGetTag$1 = interopDefault(_baseGetTag);


var require$$1$16 = Object.freeze({
	default: _baseGetTag$1
});

var _getTag = createCommonjsModule(function (module) {
var DataView = interopDefault(require$$6$2),
    Map = interopDefault(require$$5$1),
    Promise = interopDefault(require$$4$7),
    Set = interopDefault(require$$3$7),
    WeakMap = interopDefault(require$$2$13),
    baseGetTag = interopDefault(require$$1$16),
    toSource = interopDefault(require$$0$7);

/** `Object#toString` result references. */
var mapTag = '[object Map]',
    objectTag = '[object Object]',
    promiseTag = '[object Promise]',
    setTag = '[object Set]',
    weakMapTag = '[object WeakMap]';

var dataViewTag = '[object DataView]';

/** Used for built-in method references. */
var objectProto = Object.prototype;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var objectToString = objectProto.toString;

/** Used to detect maps, sets, and weakmaps. */
var dataViewCtorString = toSource(DataView),
    mapCtorString = toSource(Map),
    promiseCtorString = toSource(Promise),
    setCtorString = toSource(Set),
    weakMapCtorString = toSource(WeakMap);

/**
 * Gets the `toStringTag` of `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */
var getTag = baseGetTag;

// Fallback for data views, maps, sets, and weak maps in IE 11 and promises in Node.js < 6.
if ((DataView && getTag(new DataView(new ArrayBuffer(1))) != dataViewTag) ||
    (Map && getTag(new Map) != mapTag) ||
    (Promise && getTag(Promise.resolve()) != promiseTag) ||
    (Set && getTag(new Set) != setTag) ||
    (WeakMap && getTag(new WeakMap) != weakMapTag)) {
  getTag = function(value) {
    var result = objectToString.call(value),
        Ctor = result == objectTag ? value.constructor : undefined,
        ctorString = Ctor ? toSource(Ctor) : undefined;

    if (ctorString) {
      switch (ctorString) {
        case dataViewCtorString: return dataViewTag;
        case mapCtorString: return mapTag;
        case promiseCtorString: return promiseTag;
        case setCtorString: return setTag;
        case weakMapCtorString: return weakMapTag;
      }
    }
    return result;
  };
}

module.exports = getTag;
});

var _getTag$1 = interopDefault(_getTag);


var require$$3$6 = Object.freeze({
	default: _getTag$1
});

var stubFalse = createCommonjsModule(function (module) {
/**
 * This method returns `false`.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {boolean} Returns `false`.
 * @example
 *
 * _.times(2, _.stubFalse);
 * // => [false, false]
 */
function stubFalse() {
  return false;
}

module.exports = stubFalse;
});

var stubFalse$1 = interopDefault(stubFalse);


var require$$0$24 = Object.freeze({
	default: stubFalse$1
});

var isBuffer = createCommonjsModule(function (module, exports) {
var root = interopDefault(require$$1$5),
    stubFalse = interopDefault(require$$0$24);

/** Detect free variable `exports`. */
var freeExports = typeof exports == 'object' && exports && !exports.nodeType && exports;

/** Detect free variable `module`. */
var freeModule = freeExports && typeof module == 'object' && module && !module.nodeType && module;

/** Detect the popular CommonJS extension `module.exports`. */
var moduleExports = freeModule && freeModule.exports === freeExports;

/** Built-in value references. */
var Buffer = moduleExports ? root.Buffer : undefined;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeIsBuffer = Buffer ? Buffer.isBuffer : undefined;

/**
 * Checks if `value` is a buffer.
 *
 * @static
 * @memberOf _
 * @since 4.3.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a buffer, else `false`.
 * @example
 *
 * _.isBuffer(new Buffer(2));
 * // => true
 *
 * _.isBuffer(new Uint8Array(2));
 * // => false
 */
var isBuffer = nativeIsBuffer || stubFalse;

module.exports = isBuffer;
});

var isBuffer$1 = interopDefault(isBuffer);


var require$$1$17 = Object.freeze({
	default: isBuffer$1
});

var _baseIsTypedArray = createCommonjsModule(function (module) {
var isLength = interopDefault(require$$1$12),
    isObjectLike = interopDefault(require$$0$20);

/** `Object#toString` result references. */
var argsTag = '[object Arguments]',
    arrayTag = '[object Array]',
    boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    funcTag = '[object Function]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    objectTag = '[object Object]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    weakMapTag = '[object WeakMap]';

var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]',
    float32Tag = '[object Float32Array]',
    float64Tag = '[object Float64Array]',
    int8Tag = '[object Int8Array]',
    int16Tag = '[object Int16Array]',
    int32Tag = '[object Int32Array]',
    uint8Tag = '[object Uint8Array]',
    uint8ClampedTag = '[object Uint8ClampedArray]',
    uint16Tag = '[object Uint16Array]',
    uint32Tag = '[object Uint32Array]';

/** Used to identify `toStringTag` values of typed arrays. */
var typedArrayTags = {};
typedArrayTags[float32Tag] = typedArrayTags[float64Tag] =
typedArrayTags[int8Tag] = typedArrayTags[int16Tag] =
typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] =
typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] =
typedArrayTags[uint32Tag] = true;
typedArrayTags[argsTag] = typedArrayTags[arrayTag] =
typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] =
typedArrayTags[dataViewTag] = typedArrayTags[dateTag] =
typedArrayTags[errorTag] = typedArrayTags[funcTag] =
typedArrayTags[mapTag] = typedArrayTags[numberTag] =
typedArrayTags[objectTag] = typedArrayTags[regexpTag] =
typedArrayTags[setTag] = typedArrayTags[stringTag] =
typedArrayTags[weakMapTag] = false;

/** Used for built-in method references. */
var objectProto = Object.prototype;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var objectToString = objectProto.toString;

/**
 * The base implementation of `_.isTypedArray` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 */
function baseIsTypedArray(value) {
  return isObjectLike(value) &&
    isLength(value.length) && !!typedArrayTags[objectToString.call(value)];
}

module.exports = baseIsTypedArray;
});

var _baseIsTypedArray$1 = interopDefault(_baseIsTypedArray);


var require$$2$14 = Object.freeze({
	default: _baseIsTypedArray$1
});

var _baseUnary = createCommonjsModule(function (module) {
/**
 * The base implementation of `_.unary` without support for storing metadata.
 *
 * @private
 * @param {Function} func The function to cap arguments for.
 * @returns {Function} Returns the new capped function.
 */
function baseUnary(func) {
  return function(value) {
    return func(value);
  };
}

module.exports = baseUnary;
});

var _baseUnary$1 = interopDefault(_baseUnary);


var require$$2$15 = Object.freeze({
	default: _baseUnary$1
});

var _nodeUtil = createCommonjsModule(function (module, exports) {
var freeGlobal = interopDefault(require$$0$6);

/** Detect free variable `exports`. */
var freeExports = typeof exports == 'object' && exports && !exports.nodeType && exports;

/** Detect free variable `module`. */
var freeModule = freeExports && typeof module == 'object' && module && !module.nodeType && module;

/** Detect the popular CommonJS extension `module.exports`. */
var moduleExports = freeModule && freeModule.exports === freeExports;

/** Detect free variable `process` from Node.js. */
var freeProcess = moduleExports && freeGlobal.process;

/** Used to access faster Node.js helpers. */
var nodeUtil = (function() {
  try {
    return freeProcess && freeProcess.binding('util');
  } catch (e) {}
}());

module.exports = nodeUtil;
});

var _nodeUtil$1 = interopDefault(_nodeUtil);


var require$$0$26 = Object.freeze({
	default: _nodeUtil$1
});

var isTypedArray = createCommonjsModule(function (module) {
var baseIsTypedArray = interopDefault(require$$2$14),
    baseUnary = interopDefault(require$$2$15),
    nodeUtil = interopDefault(require$$0$26);

/* Node.js helper references. */
var nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;

/**
 * Checks if `value` is classified as a typed array.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 * @example
 *
 * _.isTypedArray(new Uint8Array);
 * // => true
 *
 * _.isTypedArray([]);
 * // => false
 */
var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;

module.exports = isTypedArray;
});

var isTypedArray$1 = interopDefault(isTypedArray);


var require$$0$25 = Object.freeze({
	default: isTypedArray$1
});

var _baseIsEqualDeep = createCommonjsModule(function (module) {
var Stack = interopDefault(require$$7),
    equalArrays = interopDefault(require$$2$8),
    equalByTag = interopDefault(require$$5$2),
    equalObjects = interopDefault(require$$4$6),
    getTag = interopDefault(require$$3$6),
    isArray = interopDefault(require$$0$21),
    isBuffer = interopDefault(require$$1$17),
    isTypedArray = interopDefault(require$$0$25);

/** Used to compose bitmasks for comparison styles. */
var PARTIAL_COMPARE_FLAG = 2;

/** `Object#toString` result references. */
var argsTag = '[object Arguments]',
    arrayTag = '[object Array]',
    objectTag = '[object Object]';

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * A specialized version of `baseIsEqual` for arrays and objects which performs
 * deep comparisons and tracks traversed objects enabling objects with circular
 * references to be compared.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Function} [customizer] The function to customize comparisons.
 * @param {number} [bitmask] The bitmask of comparison flags. See `baseIsEqual`
 *  for more details.
 * @param {Object} [stack] Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function baseIsEqualDeep(object, other, equalFunc, customizer, bitmask, stack) {
  var objIsArr = isArray(object),
      othIsArr = isArray(other),
      objTag = arrayTag,
      othTag = arrayTag;

  if (!objIsArr) {
    objTag = getTag(object);
    objTag = objTag == argsTag ? objectTag : objTag;
  }
  if (!othIsArr) {
    othTag = getTag(other);
    othTag = othTag == argsTag ? objectTag : othTag;
  }
  var objIsObj = objTag == objectTag,
      othIsObj = othTag == objectTag,
      isSameTag = objTag == othTag;

  if (isSameTag && isBuffer(object)) {
    if (!isBuffer(other)) {
      return false;
    }
    objIsArr = true;
    objIsObj = false;
  }
  if (isSameTag && !objIsObj) {
    stack || (stack = new Stack);
    return (objIsArr || isTypedArray(object))
      ? equalArrays(object, other, equalFunc, customizer, bitmask, stack)
      : equalByTag(object, other, objTag, equalFunc, customizer, bitmask, stack);
  }
  if (!(bitmask & PARTIAL_COMPARE_FLAG)) {
    var objIsWrapped = objIsObj && hasOwnProperty.call(object, '__wrapped__'),
        othIsWrapped = othIsObj && hasOwnProperty.call(other, '__wrapped__');

    if (objIsWrapped || othIsWrapped) {
      var objUnwrapped = objIsWrapped ? object.value() : object,
          othUnwrapped = othIsWrapped ? other.value() : other;

      stack || (stack = new Stack);
      return equalFunc(objUnwrapped, othUnwrapped, customizer, bitmask, stack);
    }
  }
  if (!isSameTag) {
    return false;
  }
  stack || (stack = new Stack);
  return equalObjects(object, other, equalFunc, customizer, bitmask, stack);
}

module.exports = baseIsEqualDeep;
});

var _baseIsEqualDeep$1 = interopDefault(_baseIsEqualDeep);


var require$$2$7 = Object.freeze({
	default: _baseIsEqualDeep$1
});

var _baseIsEqual = createCommonjsModule(function (module) {
var baseIsEqualDeep = interopDefault(require$$2$7),
    isObject = interopDefault(require$$0$4),
    isObjectLike = interopDefault(require$$0$20);

/**
 * The base implementation of `_.isEqual` which supports partial comparisons
 * and tracks traversed objects.
 *
 * @private
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @param {Function} [customizer] The function to customize comparisons.
 * @param {boolean} [bitmask] The bitmask of comparison flags.
 *  The bitmask may be composed of the following flags:
 *     1 - Unordered comparison
 *     2 - Partial comparison
 * @param {Object} [stack] Tracks traversed `value` and `other` objects.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 */
function baseIsEqual(value, other, customizer, bitmask, stack) {
  if (value === other) {
    return true;
  }
  if (value == null || other == null || (!isObject(value) && !isObjectLike(other))) {
    return value !== value && other !== other;
  }
  return baseIsEqualDeep(value, other, baseIsEqual, customizer, bitmask, stack);
}

module.exports = baseIsEqual;
});

var _baseIsEqual$1 = interopDefault(_baseIsEqual);


var require$$6$1 = Object.freeze({
	default: _baseIsEqual$1
});

var _baseIsMatch = createCommonjsModule(function (module) {
var Stack = interopDefault(require$$7),
    baseIsEqual = interopDefault(require$$6$1);

/** Used to compose bitmasks for comparison styles. */
var UNORDERED_COMPARE_FLAG = 1,
    PARTIAL_COMPARE_FLAG = 2;

/**
 * The base implementation of `_.isMatch` without support for iteratee shorthands.
 *
 * @private
 * @param {Object} object The object to inspect.
 * @param {Object} source The object of property values to match.
 * @param {Array} matchData The property names, values, and compare flags to match.
 * @param {Function} [customizer] The function to customize comparisons.
 * @returns {boolean} Returns `true` if `object` is a match, else `false`.
 */
function baseIsMatch(object, source, matchData, customizer) {
  var index = matchData.length,
      length = index,
      noCustomizer = !customizer;

  if (object == null) {
    return !length;
  }
  object = Object(object);
  while (index--) {
    var data = matchData[index];
    if ((noCustomizer && data[2])
          ? data[1] !== object[data[0]]
          : !(data[0] in object)
        ) {
      return false;
    }
  }
  while (++index < length) {
    data = matchData[index];
    var key = data[0],
        objValue = object[key],
        srcValue = data[1];

    if (noCustomizer && data[2]) {
      if (objValue === undefined && !(key in object)) {
        return false;
      }
    } else {
      var stack = new Stack;
      if (customizer) {
        var result = customizer(objValue, srcValue, key, object, source, stack);
      }
      if (!(result === undefined
            ? baseIsEqual(srcValue, objValue, customizer, UNORDERED_COMPARE_FLAG | PARTIAL_COMPARE_FLAG, stack)
            : result
          )) {
        return false;
      }
    }
  }
  return true;
}

module.exports = baseIsMatch;
});

var _baseIsMatch$1 = interopDefault(_baseIsMatch);


var require$$2 = Object.freeze({
	default: _baseIsMatch$1
});

var _isStrictComparable = createCommonjsModule(function (module) {
var isObject = interopDefault(require$$0$4);

/**
 * Checks if `value` is suitable for strict equality comparisons, i.e. `===`.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` if suitable for strict
 *  equality comparisons, else `false`.
 */
function isStrictComparable(value) {
  return value === value && !isObject(value);
}

module.exports = isStrictComparable;
});

var _isStrictComparable$1 = interopDefault(_isStrictComparable);


var require$$2$16 = Object.freeze({
	default: _isStrictComparable$1
});

var _getMatchData = createCommonjsModule(function (module) {
var isStrictComparable = interopDefault(require$$2$16),
    keys = interopDefault(require$$0$18);

/**
 * Gets the property names, values, and compare flags of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the match data of `object`.
 */
function getMatchData(object) {
  var result = keys(object),
      length = result.length;

  while (length--) {
    var key = result[length],
        value = object[key];

    result[length] = [key, value, isStrictComparable(value)];
  }
  return result;
}

module.exports = getMatchData;
});

var _getMatchData$1 = interopDefault(_getMatchData);


var require$$1$18 = Object.freeze({
	default: _getMatchData$1
});

var _matchesStrictComparable = createCommonjsModule(function (module) {
/**
 * A specialized version of `matchesProperty` for source values suitable
 * for strict equality comparisons, i.e. `===`.
 *
 * @private
 * @param {string} key The key of the property to get.
 * @param {*} srcValue The value to match.
 * @returns {Function} Returns the new spec function.
 */
function matchesStrictComparable(key, srcValue) {
  return function(object) {
    if (object == null) {
      return false;
    }
    return object[key] === srcValue &&
      (srcValue !== undefined || (key in Object(object)));
  };
}

module.exports = matchesStrictComparable;
});

var _matchesStrictComparable$1 = interopDefault(_matchesStrictComparable);


var require$$1$19 = Object.freeze({
	default: _matchesStrictComparable$1
});

var _baseMatches = createCommonjsModule(function (module) {
var baseIsMatch = interopDefault(require$$2),
    getMatchData = interopDefault(require$$1$18),
    matchesStrictComparable = interopDefault(require$$1$19);

/**
 * The base implementation of `_.matches` which doesn't clone `source`.
 *
 * @private
 * @param {Object} source The object of property values to match.
 * @returns {Function} Returns the new spec function.
 */
function baseMatches(source) {
  var matchData = getMatchData(source);
  if (matchData.length == 1 && matchData[0][2]) {
    return matchesStrictComparable(matchData[0][0], matchData[0][1]);
  }
  return function(object) {
    return object === source || baseIsMatch(object, source, matchData);
  };
}

module.exports = baseMatches;
});

var _baseMatches$1 = interopDefault(_baseMatches);


var require$$4 = Object.freeze({
	default: _baseMatches$1
});

var memoize = createCommonjsModule(function (module) {
var MapCache = interopDefault(require$$0$9);

/** Error message constants. */
var FUNC_ERROR_TEXT = 'Expected a function';

/**
 * Creates a function that memoizes the result of `func`. If `resolver` is
 * provided, it determines the cache key for storing the result based on the
 * arguments provided to the memoized function. By default, the first argument
 * provided to the memoized function is used as the map cache key. The `func`
 * is invoked with the `this` binding of the memoized function.
 *
 * **Note:** The cache is exposed as the `cache` property on the memoized
 * function. Its creation may be customized by replacing the `_.memoize.Cache`
 * constructor with one whose instances implement the
 * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)
 * method interface of `delete`, `get`, `has`, and `set`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to have its output memoized.
 * @param {Function} [resolver] The function to resolve the cache key.
 * @returns {Function} Returns the new memoized function.
 * @example
 *
 * var object = { 'a': 1, 'b': 2 };
 * var other = { 'c': 3, 'd': 4 };
 *
 * var values = _.memoize(_.values);
 * values(object);
 * // => [1, 2]
 *
 * values(other);
 * // => [3, 4]
 *
 * object.a = 2;
 * values(object);
 * // => [1, 2]
 *
 * // Modify the result cache.
 * values.cache.set(object, ['a', 'b']);
 * values(object);
 * // => ['a', 'b']
 *
 * // Replace `_.memoize.Cache`.
 * _.memoize.Cache = WeakMap;
 */
function memoize(func, resolver) {
  if (typeof func != 'function' || (resolver && typeof resolver != 'function')) {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  var memoized = function() {
    var args = arguments,
        key = resolver ? resolver.apply(this, args) : args[0],
        cache = memoized.cache;

    if (cache.has(key)) {
      return cache.get(key);
    }
    var result = func.apply(this, args);
    memoized.cache = cache.set(key, result) || cache;
    return result;
  };
  memoized.cache = new (memoize.Cache || MapCache);
  return memoized;
}

// Expose `MapCache`.
memoize.Cache = MapCache;

module.exports = memoize;
});

var memoize$1 = interopDefault(memoize);


var require$$0$29 = Object.freeze({
	default: memoize$1
});

var _memoizeCapped = createCommonjsModule(function (module) {
var memoize = interopDefault(require$$0$29);

/** Used as the maximum memoize cache size. */
var MAX_MEMOIZE_SIZE = 500;

/**
 * A specialized version of `_.memoize` which clears the memoized function's
 * cache when it exceeds `MAX_MEMOIZE_SIZE`.
 *
 * @private
 * @param {Function} func The function to have its output memoized.
 * @returns {Function} Returns the new memoized function.
 */
function memoizeCapped(func) {
  var result = memoize(func, function(key) {
    if (cache.size === MAX_MEMOIZE_SIZE) {
      cache.clear();
    }
    return key;
  });

  var cache = result.cache;
  return result;
}

module.exports = memoizeCapped;
});

var _memoizeCapped$1 = interopDefault(_memoizeCapped);


var require$$1$20 = Object.freeze({
	default: _memoizeCapped$1
});

var isSymbol = createCommonjsModule(function (module) {
var isObjectLike = interopDefault(require$$0$20);

/** `Object#toString` result references. */
var symbolTag = '[object Symbol]';

/** Used for built-in method references. */
var objectProto = Object.prototype;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var objectToString = objectProto.toString;

/**
 * Checks if `value` is classified as a `Symbol` primitive or object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
 * @example
 *
 * _.isSymbol(Symbol.iterator);
 * // => true
 *
 * _.isSymbol('abc');
 * // => false
 */
function isSymbol(value) {
  return typeof value == 'symbol' ||
    (isObjectLike(value) && objectToString.call(value) == symbolTag);
}

module.exports = isSymbol;
});

var isSymbol$1 = interopDefault(isSymbol);


var require$$0$32 = Object.freeze({
	default: isSymbol$1
});

var _baseToString = createCommonjsModule(function (module) {
var Symbol = interopDefault(require$$2$10),
    isSymbol = interopDefault(require$$0$32);

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0;

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol ? Symbol.prototype : undefined,
    symbolToString = symbolProto ? symbolProto.toString : undefined;

/**
 * The base implementation of `_.toString` which doesn't convert nullish
 * values to empty strings.
 *
 * @private
 * @param {*} value The value to process.
 * @returns {string} Returns the string.
 */
function baseToString(value) {
  // Exit early for strings to avoid a performance hit in some environments.
  if (typeof value == 'string') {
    return value;
  }
  if (isSymbol(value)) {
    return symbolToString ? symbolToString.call(value) : '';
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
}

module.exports = baseToString;
});

var _baseToString$1 = interopDefault(_baseToString);


var require$$0$31 = Object.freeze({
	default: _baseToString$1
});

var toString = createCommonjsModule(function (module) {
var baseToString = interopDefault(require$$0$31);

/**
 * Converts `value` to a string. An empty string is returned for `null`
 * and `undefined` values. The sign of `-0` is preserved.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to process.
 * @returns {string} Returns the string.
 * @example
 *
 * _.toString(null);
 * // => ''
 *
 * _.toString(-0);
 * // => '-0'
 *
 * _.toString([1, 2, 3]);
 * // => '1,2,3'
 */
function toString(value) {
  return value == null ? '' : baseToString(value);
}

module.exports = toString;
});

var toString$1 = interopDefault(toString);


var require$$0$30 = Object.freeze({
	default: toString$1
});

var _stringToPath = createCommonjsModule(function (module) {
var memoizeCapped = interopDefault(require$$1$20),
    toString = interopDefault(require$$0$30);

/** Used to match property names within property paths. */
var reLeadingDot = /^\./,
    rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;

/** Used to match backslashes in property paths. */
var reEscapeChar = /\\(\\)?/g;

/**
 * Converts `string` to a property path array.
 *
 * @private
 * @param {string} string The string to convert.
 * @returns {Array} Returns the property path array.
 */
var stringToPath = memoizeCapped(function(string) {
  string = toString(string);

  var result = [];
  if (reLeadingDot.test(string)) {
    result.push('');
  }
  string.replace(rePropName, function(match, number, quote, string) {
    result.push(quote ? string.replace(reEscapeChar, '$1') : (number || match));
  });
  return result;
});

module.exports = stringToPath;
});

var _stringToPath$1 = interopDefault(_stringToPath);


var require$$0$28 = Object.freeze({
	default: _stringToPath$1
});

var _castPath = createCommonjsModule(function (module) {
var isArray = interopDefault(require$$0$21),
    stringToPath = interopDefault(require$$0$28);

/**
 * Casts `value` to a path array if it's not one.
 *
 * @private
 * @param {*} value The value to inspect.
 * @returns {Array} Returns the cast property path array.
 */
function castPath(value) {
  return isArray(value) ? value : stringToPath(value);
}

module.exports = castPath;
});

var _castPath$1 = interopDefault(_castPath);


var require$$6$3 = Object.freeze({
	default: _castPath$1
});

var _isKey = createCommonjsModule(function (module) {
var isArray = interopDefault(require$$0$21),
    isSymbol = interopDefault(require$$0$32);

/** Used to match property names within property paths. */
var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
    reIsPlainProp = /^\w*$/;

/**
 * Checks if `value` is a property name and not a property path.
 *
 * @private
 * @param {*} value The value to check.
 * @param {Object} [object] The object to query keys on.
 * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
 */
function isKey(value, object) {
  if (isArray(value)) {
    return false;
  }
  var type = typeof value;
  if (type == 'number' || type == 'symbol' || type == 'boolean' ||
      value == null || isSymbol(value)) {
    return true;
  }
  return reIsPlainProp.test(value) || !reIsDeepProp.test(value) ||
    (object != null && value in Object(object));
}

module.exports = isKey;
});

var _isKey$1 = interopDefault(_isKey);


var require$$1$21 = Object.freeze({
	default: _isKey$1
});

var _toKey = createCommonjsModule(function (module) {
var isSymbol = interopDefault(require$$0$32);

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0;

/**
 * Converts `value` to a string key if it's not a string or symbol.
 *
 * @private
 * @param {*} value The value to inspect.
 * @returns {string|symbol} Returns the key.
 */
function toKey(value) {
  if (typeof value == 'string' || isSymbol(value)) {
    return value;
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
}

module.exports = toKey;
});

var _toKey$1 = interopDefault(_toKey);


var require$$0$33 = Object.freeze({
	default: _toKey$1
});

var _baseGet = createCommonjsModule(function (module) {
var castPath = interopDefault(require$$6$3),
    isKey = interopDefault(require$$1$21),
    toKey = interopDefault(require$$0$33);

/**
 * The base implementation of `_.get` without support for default values.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array|string} path The path of the property to get.
 * @returns {*} Returns the resolved value.
 */
function baseGet(object, path) {
  path = isKey(path, object) ? [path] : castPath(path);

  var index = 0,
      length = path.length;

  while (object != null && index < length) {
    object = object[toKey(path[index++])];
  }
  return (index && index == length) ? object : undefined;
}

module.exports = baseGet;
});

var _baseGet$1 = interopDefault(_baseGet);


var require$$0$27 = Object.freeze({
	default: _baseGet$1
});

var get = createCommonjsModule(function (module) {
var baseGet = interopDefault(require$$0$27);

/**
 * Gets the value at `path` of `object`. If the resolved value is
 * `undefined`, the `defaultValue` is returned in its place.
 *
 * @static
 * @memberOf _
 * @since 3.7.0
 * @category Object
 * @param {Object} object The object to query.
 * @param {Array|string} path The path of the property to get.
 * @param {*} [defaultValue] The value returned for `undefined` resolved values.
 * @returns {*} Returns the resolved value.
 * @example
 *
 * var object = { 'a': [{ 'b': { 'c': 3 } }] };
 *
 * _.get(object, 'a[0].b.c');
 * // => 3
 *
 * _.get(object, ['a', '0', 'b', 'c']);
 * // => 3
 *
 * _.get(object, 'a.b.c', 'default');
 * // => 'default'
 */
function get(object, path, defaultValue) {
  var result = object == null ? undefined : baseGet(object, path);
  return result === undefined ? defaultValue : result;
}

module.exports = get;
});

var get$1 = interopDefault(get);


var require$$5$3 = Object.freeze({
	default: get$1
});

var _baseHasIn = createCommonjsModule(function (module) {
/**
 * The base implementation of `_.hasIn` without support for deep paths.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {Array|string} key The key to check.
 * @returns {boolean} Returns `true` if `key` exists, else `false`.
 */
function baseHasIn(object, key) {
  return object != null && key in Object(object);
}

module.exports = baseHasIn;
});

var _baseHasIn$1 = interopDefault(_baseHasIn);


var require$$1$22 = Object.freeze({
	default: _baseHasIn$1
});

var _hasPath = createCommonjsModule(function (module) {
var castPath = interopDefault(require$$6$3),
    isArguments = interopDefault(require$$1$11),
    isArray = interopDefault(require$$0$21),
    isIndex = interopDefault(require$$1$13),
    isKey = interopDefault(require$$1$21),
    isLength = interopDefault(require$$1$12),
    toKey = interopDefault(require$$0$33);

/**
 * Checks if `path` exists on `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array|string} path The path to check.
 * @param {Function} hasFunc The function to check properties.
 * @returns {boolean} Returns `true` if `path` exists, else `false`.
 */
function hasPath(object, path, hasFunc) {
  path = isKey(path, object) ? [path] : castPath(path);

  var index = -1,
      length = path.length,
      result = false;

  while (++index < length) {
    var key = toKey(path[index]);
    if (!(result = object != null && hasFunc(object, key))) {
      break;
    }
    object = object[key];
  }
  if (result || ++index != length) {
    return result;
  }
  length = object ? object.length : 0;
  return !!length && isLength(length) && isIndex(key, length) &&
    (isArray(object) || isArguments(object));
}

module.exports = hasPath;
});

var _hasPath$1 = interopDefault(_hasPath);


var require$$0$34 = Object.freeze({
	default: _hasPath$1
});

var hasIn = createCommonjsModule(function (module) {
var baseHasIn = interopDefault(require$$1$22),
    hasPath = interopDefault(require$$0$34);

/**
 * Checks if `path` is a direct or inherited property of `object`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Object
 * @param {Object} object The object to query.
 * @param {Array|string} path The path to check.
 * @returns {boolean} Returns `true` if `path` exists, else `false`.
 * @example
 *
 * var object = _.create({ 'a': _.create({ 'b': 2 }) });
 *
 * _.hasIn(object, 'a');
 * // => true
 *
 * _.hasIn(object, 'a.b');
 * // => true
 *
 * _.hasIn(object, ['a', 'b']);
 * // => true
 *
 * _.hasIn(object, 'b');
 * // => false
 */
function hasIn(object, path) {
  return object != null && hasPath(object, path, baseHasIn);
}

module.exports = hasIn;
});

var hasIn$1 = interopDefault(hasIn);


var require$$4$8 = Object.freeze({
	default: hasIn$1
});

var _baseMatchesProperty = createCommonjsModule(function (module) {
var baseIsEqual = interopDefault(require$$6$1),
    get = interopDefault(require$$5$3),
    hasIn = interopDefault(require$$4$8),
    isKey = interopDefault(require$$1$21),
    isStrictComparable = interopDefault(require$$2$16),
    matchesStrictComparable = interopDefault(require$$1$19),
    toKey = interopDefault(require$$0$33);

/** Used to compose bitmasks for comparison styles. */
var UNORDERED_COMPARE_FLAG = 1,
    PARTIAL_COMPARE_FLAG = 2;

/**
 * The base implementation of `_.matchesProperty` which doesn't clone `srcValue`.
 *
 * @private
 * @param {string} path The path of the property to get.
 * @param {*} srcValue The value to match.
 * @returns {Function} Returns the new spec function.
 */
function baseMatchesProperty(path, srcValue) {
  if (isKey(path) && isStrictComparable(srcValue)) {
    return matchesStrictComparable(toKey(path), srcValue);
  }
  return function(object) {
    var objValue = get(object, path);
    return (objValue === undefined && objValue === srcValue)
      ? hasIn(object, path)
      : baseIsEqual(srcValue, objValue, undefined, UNORDERED_COMPARE_FLAG | PARTIAL_COMPARE_FLAG);
  };
}

module.exports = baseMatchesProperty;
});

var _baseMatchesProperty$1 = interopDefault(_baseMatchesProperty);


var require$$3$8 = Object.freeze({
	default: _baseMatchesProperty$1
});

var identity = createCommonjsModule(function (module) {
/**
 * This method returns the first argument it receives.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Util
 * @param {*} value Any value.
 * @returns {*} Returns `value`.
 * @example
 *
 * var object = { 'a': 1 };
 *
 * console.log(_.identity(object) === object);
 * // => true
 */
function identity(value) {
  return value;
}

module.exports = identity;
});

var identity$1 = interopDefault(identity);


var require$$0$35 = Object.freeze({
	default: identity$1
});

var _baseProperty = createCommonjsModule(function (module) {
/**
 * The base implementation of `_.property` without support for deep paths.
 *
 * @private
 * @param {string} key The key of the property to get.
 * @returns {Function} Returns the new accessor function.
 */
function baseProperty(key) {
  return function(object) {
    return object == null ? undefined : object[key];
  };
}

module.exports = baseProperty;
});

var _baseProperty$1 = interopDefault(_baseProperty);


var require$$3$9 = Object.freeze({
	default: _baseProperty$1
});

var _basePropertyDeep = createCommonjsModule(function (module) {
var baseGet = interopDefault(require$$0$27);

/**
 * A specialized version of `baseProperty` which supports deep paths.
 *
 * @private
 * @param {Array|string} path The path of the property to get.
 * @returns {Function} Returns the new accessor function.
 */
function basePropertyDeep(path) {
  return function(object) {
    return baseGet(object, path);
  };
}

module.exports = basePropertyDeep;
});

var _basePropertyDeep$1 = interopDefault(_basePropertyDeep);


var require$$2$17 = Object.freeze({
	default: _basePropertyDeep$1
});

var property = createCommonjsModule(function (module) {
var baseProperty = interopDefault(require$$3$9),
    basePropertyDeep = interopDefault(require$$2$17),
    isKey = interopDefault(require$$1$21),
    toKey = interopDefault(require$$0$33);

/**
 * Creates a function that returns the value at `path` of a given object.
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Util
 * @param {Array|string} path The path of the property to get.
 * @returns {Function} Returns the new accessor function.
 * @example
 *
 * var objects = [
 *   { 'a': { 'b': 2 } },
 *   { 'a': { 'b': 1 } }
 * ];
 *
 * _.map(objects, _.property('a.b'));
 * // => [2, 1]
 *
 * _.map(_.sortBy(objects, _.property(['a', 'b'])), 'a.b');
 * // => [1, 2]
 */
function property(path) {
  return isKey(path) ? baseProperty(toKey(path)) : basePropertyDeep(path);
}

module.exports = property;
});

var property$1 = interopDefault(property);


var require$$0$36 = Object.freeze({
	default: property$1
});

var _baseIteratee = createCommonjsModule(function (module) {
var baseMatches = interopDefault(require$$4),
    baseMatchesProperty = interopDefault(require$$3$8),
    identity = interopDefault(require$$0$35),
    isArray = interopDefault(require$$0$21),
    property = interopDefault(require$$0$36);

/**
 * The base implementation of `_.iteratee`.
 *
 * @private
 * @param {*} [value=_.identity] The value to convert to an iteratee.
 * @returns {Function} Returns the iteratee.
 */
function baseIteratee(value) {
  // Don't store the `typeof` result in a variable to avoid a JIT bug in Safari 9.
  // See https://bugs.webkit.org/show_bug.cgi?id=156034 for more details.
  if (typeof value == 'function') {
    return value;
  }
  if (value == null) {
    return identity;
  }
  if (typeof value == 'object') {
    return isArray(value)
      ? baseMatchesProperty(value[0], value[1])
      : baseMatches(value);
  }
  return property(value);
}

module.exports = baseIteratee;
});

var _baseIteratee$1 = interopDefault(_baseIteratee);


var require$$5 = Object.freeze({
	default: _baseIteratee$1
});

var _createBaseFor = createCommonjsModule(function (module) {
/**
 * Creates a base function for methods like `_.forIn` and `_.forOwn`.
 *
 * @private
 * @param {boolean} [fromRight] Specify iterating from right to left.
 * @returns {Function} Returns the new base function.
 */
function createBaseFor(fromRight) {
  return function(object, iteratee, keysFunc) {
    var index = -1,
        iterable = Object(object),
        props = keysFunc(object),
        length = props.length;

    while (length--) {
      var key = props[fromRight ? length : ++index];
      if (iteratee(iterable[key], key, iterable) === false) {
        break;
      }
    }
    return object;
  };
}

module.exports = createBaseFor;
});

var _createBaseFor$1 = interopDefault(_createBaseFor);


var require$$0$37 = Object.freeze({
	default: _createBaseFor$1
});

var _baseFor = createCommonjsModule(function (module) {
var createBaseFor = interopDefault(require$$0$37);

/**
 * The base implementation of `baseForOwn` which iterates over `object`
 * properties returned by `keysFunc` and invokes `iteratee` for each property.
 * Iteratee functions may exit iteration early by explicitly returning `false`.
 *
 * @private
 * @param {Object} object The object to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @param {Function} keysFunc The function to get the keys of `object`.
 * @returns {Object} Returns `object`.
 */
var baseFor = createBaseFor();

module.exports = baseFor;
});

var _baseFor$1 = interopDefault(_baseFor);


var require$$1$24 = Object.freeze({
	default: _baseFor$1
});

var _baseForOwn = createCommonjsModule(function (module) {
var baseFor = interopDefault(require$$1$24),
    keys = interopDefault(require$$0$18);

/**
 * The base implementation of `_.forOwn` without support for iteratee shorthands.
 *
 * @private
 * @param {Object} object The object to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Object} Returns `object`.
 */
function baseForOwn(object, iteratee) {
  return object && baseFor(object, iteratee, keys);
}

module.exports = baseForOwn;
});

var _baseForOwn$1 = interopDefault(_baseForOwn);


var require$$1$23 = Object.freeze({
	default: _baseForOwn$1
});

var _createBaseEach = createCommonjsModule(function (module) {
var isArrayLike = interopDefault(require$$2$12);

/**
 * Creates a `baseEach` or `baseEachRight` function.
 *
 * @private
 * @param {Function} eachFunc The function to iterate over a collection.
 * @param {boolean} [fromRight] Specify iterating from right to left.
 * @returns {Function} Returns the new base function.
 */
function createBaseEach(eachFunc, fromRight) {
  return function(collection, iteratee) {
    if (collection == null) {
      return collection;
    }
    if (!isArrayLike(collection)) {
      return eachFunc(collection, iteratee);
    }
    var length = collection.length,
        index = fromRight ? length : -1,
        iterable = Object(collection);

    while ((fromRight ? index-- : ++index < length)) {
      if (iteratee(iterable[index], index, iterable) === false) {
        break;
      }
    }
    return collection;
  };
}

module.exports = createBaseEach;
});

var _createBaseEach$1 = interopDefault(_createBaseEach);


var require$$0$38 = Object.freeze({
	default: _createBaseEach$1
});

var _baseEach = createCommonjsModule(function (module) {
var baseForOwn = interopDefault(require$$1$23),
    createBaseEach = interopDefault(require$$0$38);

/**
 * The base implementation of `_.forEach` without support for iteratee shorthands.
 *
 * @private
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array|Object} Returns `collection`.
 */
var baseEach = createBaseEach(baseForOwn);

module.exports = baseEach;
});

var _baseEach$1 = interopDefault(_baseEach);


var require$$2$18 = Object.freeze({
	default: _baseEach$1
});

var _baseMap = createCommonjsModule(function (module) {
var baseEach = interopDefault(require$$2$18),
    isArrayLike = interopDefault(require$$2$12);

/**
 * The base implementation of `_.map` without support for iteratee shorthands.
 *
 * @private
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the new mapped array.
 */
function baseMap(collection, iteratee) {
  var index = -1,
      result = isArrayLike(collection) ? Array(collection.length) : [];

  baseEach(collection, function(value, key, collection) {
    result[++index] = iteratee(value, key, collection);
  });
  return result;
}

module.exports = baseMap;
});

var _baseMap$1 = interopDefault(_baseMap);


var require$$4$9 = Object.freeze({
	default: _baseMap$1
});

var map = createCommonjsModule(function (module) {
var arrayMap = interopDefault(require$$6),
    baseIteratee = interopDefault(require$$5),
    baseMap = interopDefault(require$$4$9),
    isArray = interopDefault(require$$0$21);

/**
 * Creates an array of values by running each element in `collection` thru
 * `iteratee`. The iteratee is invoked with three arguments:
 * (value, index|key, collection).
 *
 * Many lodash methods are guarded to work as iteratees for methods like
 * `_.every`, `_.filter`, `_.map`, `_.mapValues`, `_.reject`, and `_.some`.
 *
 * The guarded methods are:
 * `ary`, `chunk`, `curry`, `curryRight`, `drop`, `dropRight`, `every`,
 * `fill`, `invert`, `parseInt`, `random`, `range`, `rangeRight`, `repeat`,
 * `sampleSize`, `slice`, `some`, `sortBy`, `split`, `take`, `takeRight`,
 * `template`, `trim`, `trimEnd`, `trimStart`, and `words`
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Collection
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} [iteratee=_.identity] The function invoked per iteration.
 * @returns {Array} Returns the new mapped array.
 * @example
 *
 * function square(n) {
 *   return n * n;
 * }
 *
 * _.map([4, 8], square);
 * // => [16, 64]
 *
 * _.map({ 'a': 4, 'b': 8 }, square);
 * // => [16, 64] (iteration order is not guaranteed)
 *
 * var users = [
 *   { 'user': 'barney' },
 *   { 'user': 'fred' }
 * ];
 *
 * // The `_.property` iteratee shorthand.
 * _.map(users, 'user');
 * // => ['barney', 'fred']
 */
function map(collection, iteratee) {
  var func = isArray(collection) ? arrayMap : baseMap;
  return func(collection, baseIteratee(iteratee, 3));
}

module.exports = map;
});

var map$1 = interopDefault(map);

class MemberIndex extends substance.NodeIndex {

  constructor(doc) {
    super()

    this.doc = doc
    this.index = new substance.TreeIndex()
  }

  /**
    Selects all nodes which have a parent.

    @param {Node}
    @returns {Boolean} true if the given node should be added to the index.
   */
  select(node) {
    return node.hasParent()
  }

  _getPath(node, parentId) {
    var doc = this.doc
    parentId = parentId || node.parent
    var type = node.type
    var parent = doc.get(parentId)

    if (!parent) {
      console.error('Could not retrieve parent node of member.')
      return [parentId, type, node.name]
    }

    if (parent.type === "class") {
      if (node.isStatic || type === "ctor") {
        return [parentId, 'class', type, node.name]
      } else {
        return [parentId, 'instance', type, node.name]
      }
    } else {
      return [parentId, type, node.name]
    }
  }

  /**
    Called when a node has been created.

    @param {Node} node
   */
  create(node) {
    this.index.set(this._getPath(node), node)
  }

  /**
    Called when a node has been deleted.

    @param {Node} node
   */
  delete(node) {
    this.index.delete(this._getPath(node))
  }

  /**
    Called when a property has been updated.

    @param {Node} node
   */
  update(node, path, newValue, oldValue) {
    if (!this.select(node) || path[1] !== 'parent') return
    this.index.delete(this._getPath(node, oldValue))
    this.index.set(this._getPath(node, newValue), node)
  }

  clone() {
    return new MemberIndex(this.doc)
  }

}

function getBasename(p) {
  let idx = p.lastIndexOf('/')
  if (idx > -1) {
    return p.slice(idx+1)
  } else {
    return p
  }
}

const CLASS_PREFIX = /^([^.#]+)([.#])([^.#]+)/
const DOT = '.'.charCodeAt(0)

class LookupTable extends substance.NodeIndex {

  constructor(doc) {
    super()
    this.doc = doc
    this.table = new substance.TreeIndex.Arrays()
  }

  select(node) {
    return node.isAPINode
  }

  /*
    Classes:
      - fully-qualified: `ui/Component`
      - short: `Component`
    Instance Methods:
      - fully-qualified: ui/Component#foo()
      - short: Component#foo
    Instance Properties:
      - fully-qualified: ui/Component#baz
      - short: Component#baz
      - alias: if no name clash it is fine to register it as Component.bar
    Static Methods/Properties:
      - same but with '.'
  */
  create(node) {
    // get all aliases for which we want this node be registered
    let base = getBasename(node.id)
    switch (node.type) {
      case 'class':
      case 'module':
        this.table.add(base, node.id)
        break
      default:
        //
    }
  }

  delete(node) {
    let base = getBasename(node.id)
    this.table.remove(base, node.id)
  }

  clone() {
    return new LookupTable(this.doc)
  }

  lookupId(id, hints) {
    const doc = this.doc
    // the simplest case: id is fully qualified
    if (doc.contains(id)) {
      return id
    }
    // next we try use the short name
    // and see if it leads to something
    // e.g. 'Component' instead of 'ui/Component'
    const base = getBasename(id)
    let candidates = this.table.get(base) || []
    if (candidates.length === 1) {
      return candidates[0]
    } else if (candidates.length > 2) {
      return this._disambiguate(id, candidates, hints)
    }
    // now we look it is a composed id, e.g. Foo.bar
    let m
    if (candidates.length === 0) {
      m = CLASS_PREFIX.exec(id)
      if (m) {
        const parentId = this.lookupId(m[1])
        const parent = parentId ? doc.get(parentId) : null
        return this._lookupProp(parent, m[2], m[3])
      }
    }
    // giving up
    return ''
  }

  _lookupProp(parent, sep, name) {
    const doc = this.doc
    // try the given one first
    let id = parent.id+sep+name
    if (doc.contains(id)) return id
    // Maybe tried to access an instance prop using DOT notation
    if (parent.type === 'class' && sep.charCodeAt(0) === DOT) {
      id = parent.id+'#'+name
      if (doc.contains(id)) return id
    }
    // last we try to call that again but with '()''
    if (!/\(\)$/.exec(id)) {
      return this._lookupProp(parent, sep, name+'()')
    }
    return ''
  }

  _disambiguate(id, candidates, hints) { // eslint-disable-line
    // TODO: when we face a situation with name clashes
    // then we need to use the hints somehow, to disambiguate in a meaningful way
    console.warn('Multiple classes or modules exist with the same simple name', getBasename(id))
    return candidates[0]
  }

}

class Page extends substance.DocumentNode {
  getTitle() {
    return this.title
  }
  getSections() {
    const doc = this.getDocument()
    return this.sections.map(function(id) {
      return doc.get(id)
    }).filter(Boolean)
  }
}

Page.type = 'page'

Page.define({
  title: 'string',
  description: 'string', // HTML
  sections: { type: ['array', 'id'], default: [] }
})

Page.prototype.isContentNode = true

class APIPage extends substance.DocumentNode {
  getTitle() {
    return 'API'
  }
}

APIPage.type = 'api-page'

APIPage.define({
  nodes: {type: ['array', 'id'], default: [] },
  description: {type: 'string', default: ''}
})

class Section extends substance.DocumentNode {
  getTitle() {
    return this.title || ''
  }
  getPage() {
    return this.getDocument().get(this.page)
  }
}

Section.type = 'section'

Section.define({
  // should be a page
  page: 'id',
  title: 'text',
  level: { type: 'number', default: 1 },
  description: { type: 'string', default: '' }, // plain HTML
})

Section.prototype.isContentNode = true

var _arrayFilter = createCommonjsModule(function (module) {
/**
 * A specialized version of `_.filter` for arrays without support for
 * iteratee shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {Array} Returns the new filtered array.
 */
function arrayFilter(array, predicate) {
  var index = -1,
      length = array ? array.length : 0,
      resIndex = 0,
      result = [];

  while (++index < length) {
    var value = array[index];
    if (predicate(value, index, array)) {
      result[resIndex++] = value;
    }
  }
  return result;
}

module.exports = arrayFilter;
});

var _arrayFilter$1 = interopDefault(_arrayFilter);


var require$$3$10 = Object.freeze({
	default: _arrayFilter$1
});

var _baseFilter = createCommonjsModule(function (module) {
var baseEach = interopDefault(require$$2$18);

/**
 * The base implementation of `_.filter` without support for iteratee shorthands.
 *
 * @private
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {Array} Returns the new filtered array.
 */
function baseFilter(collection, predicate) {
  var result = [];
  baseEach(collection, function(value, index, collection) {
    if (predicate(value, index, collection)) {
      result.push(value);
    }
  });
  return result;
}

module.exports = baseFilter;
});

var _baseFilter$1 = interopDefault(_baseFilter);


var require$$2$19 = Object.freeze({
	default: _baseFilter$1
});

var filter = createCommonjsModule(function (module) {
var arrayFilter = interopDefault(require$$3$10),
    baseFilter = interopDefault(require$$2$19),
    baseIteratee = interopDefault(require$$5),
    isArray = interopDefault(require$$0$21);

/**
 * Iterates over elements of `collection`, returning an array of all elements
 * `predicate` returns truthy for. The predicate is invoked with three
 * arguments: (value, index|key, collection).
 *
 * **Note:** Unlike `_.remove`, this method returns a new array.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Collection
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} [predicate=_.identity]
 *  The function invoked per iteration.
 * @returns {Array} Returns the new filtered array.
 * @see _.reject
 * @example
 *
 * var users = [
 *   { 'user': 'barney', 'age': 36, 'active': true },
 *   { 'user': 'fred',   'age': 40, 'active': false }
 * ];
 *
 * _.filter(users, function(o) { return !o.active; });
 * // => objects for ['fred']
 *
 * // The `_.matches` iteratee shorthand.
 * _.filter(users, { 'age': 36, 'active': true });
 * // => objects for ['barney']
 *
 * // The `_.matchesProperty` iteratee shorthand.
 * _.filter(users, ['active', false]);
 * // => objects for ['fred']
 *
 * // The `_.property` iteratee shorthand.
 * _.filter(users, 'active');
 * // => objects for ['barney']
 */
function filter(collection, predicate) {
  var func = isArray(collection) ? arrayFilter : baseFilter;
  return func(collection, baseIteratee(predicate, 3));
}

module.exports = filter;
});

var filter$1 = interopDefault(filter);

var _arrayEach = createCommonjsModule(function (module) {
/**
 * A specialized version of `_.forEach` for arrays without support for
 * iteratee shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns `array`.
 */
function arrayEach(array, iteratee) {
  var index = -1,
      length = array ? array.length : 0;

  while (++index < length) {
    if (iteratee(array[index], index, array) === false) {
      break;
    }
  }
  return array;
}

module.exports = arrayEach;
});

var _arrayEach$1 = interopDefault(_arrayEach);


var require$$3$11 = Object.freeze({
	default: _arrayEach$1
});

var forEach = createCommonjsModule(function (module) {
var arrayEach = interopDefault(require$$3$11),
    baseEach = interopDefault(require$$2$18),
    baseIteratee = interopDefault(require$$5),
    isArray = interopDefault(require$$0$21);

/**
 * Iterates over elements of `collection` and invokes `iteratee` for each element.
 * The iteratee is invoked with three arguments: (value, index|key, collection).
 * Iteratee functions may exit iteration early by explicitly returning `false`.
 *
 * **Note:** As with other "Collections" methods, objects with a "length"
 * property are iterated like arrays. To avoid this behavior use `_.forIn`
 * or `_.forOwn` for object iteration.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @alias each
 * @category Collection
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} [iteratee=_.identity] The function invoked per iteration.
 * @returns {Array|Object} Returns `collection`.
 * @see _.forEachRight
 * @example
 *
 * _.forEach([1, 2], function(value) {
 *   console.log(value);
 * });
 * // => Logs `1` then `2`.
 *
 * _.forEach({ 'a': 1, 'b': 2 }, function(value, key) {
 *   console.log(key);
 * });
 * // => Logs 'a' then 'b' (iteration order is not guaranteed).
 */
function forEach(collection, iteratee) {
  var func = isArray(collection) ? arrayEach : baseEach;
  return func(collection, baseIteratee(iteratee, 3));
}

module.exports = forEach;
});

var forEach$1 = interopDefault(forEach);


var require$$0$39 = Object.freeze({
	default: forEach$1
});

let MemberContainerMixin = {

  getMembers: function(config) {
    config = config || {}
    var members = []
    forEach$1(this.getMemberCategories(), function(cat) {
      var catMembers = this.getCategoryMembers(cat, config)
      members = members.concat(catMembers)
    }.bind(this))
    return members
  },

  getCategoryMembers: function(cat, config) {
    var doc = this.getDocument()
    var memberIndex = doc.getIndex('members')
    var members = memberIndex.get([this.id].concat(cat.path))
    members = filter$1(members, function(memberNode) {
      // skip nodes according to configuration
      if ((memberNode.isPrivate && config.skipPrivateMethods) ||
        (memberNode.type === "class" && memberNode.isAbstract && config.skipAbstractClasses)) {
        return false
      }
      return true
    })
    return members
  },
}

var MEMBER_CATEGORIES = {
  'classes': {name: 'classes', path: ['class']},
  'functions': {name: 'functions', path: ['function']},
  'properties': {name: 'properties', path: ['property']},
}

class FileNode extends substance.DocumentNode {
  getMemberCategories() {
    return MEMBER_CATEGORIES
  }
}

Object.assign(FileNode.prototype, MemberContainerMixin)

FileNode.type = 'file';

FileNode.define({
  api: 'id',
  members: { type: ['array', 'id'], default: [] },
});

FileNode.isBlock = true

FileNode.prototype.isAPINode = true

class APINode extends substance.DocumentNode {
  constructor(doc, props) {
    super(doc, props)
    let _tags = {}
    this.tags.forEach(function(tag) {
      _tags[tag.type] = tag
    })
    this._tags = _tags
  }
  // Defaults to the regular type property
  getSpecificType() {
    return this.type
  }
  getAPIPage() {
    return this.getDocument().get(this.api)
  }
  hasTag(name) {
    return Boolean(this._tags[name])
  }
}

APINode.define({
  api: 'id',
  description: { type: 'string', optional: true }, // HTML
  example: { type: 'string', optional: true }, // HTML
  sourceFile: 'string', // ui/Component.js
  sourceLine: 'number',
  tags: { type: ['array', 'object'], default: [] }, // [ { name: 'type', string: '...', html: '...'}]
  isUndocumented: { type: 'boolean', default: false },
})

APINode.isBlock = true

APINode.prototype.isAPINode = true

var MEMBER_CATEGORIES$1 = {
  'classes': {name: 'classes', path: ['class']},
  'methods': {name: 'methods', path: ['method']},
  'properties': {name: 'properties', path: ['property']},
}

class ModuleNode extends APINode {
  getName() {
    return this.name
  }
  getMemberCategories() {
    return MEMBER_CATEGORIES$1
  }
  getMembers() {
    const doc = this.getDocument()
    return this.members.map(function(id) { return doc.get(id) })
  }
}

Object.assign(ModuleNode.prototype, MemberContainerMixin)


ModuleNode.type = 'module'

ModuleNode.define({
  name: 'string',
  members: { type: ['array', 'property'], default: [] }, // ['model/documentHelpers.getAllAnnotations']
})

ModuleNode.isBlock = true

class FunctionNode extends APINode {
  getName() {
    return this.name
  }
  getParent() {
    return this.getDocument().get(this.parent)
  }
}

FunctionNode.type = 'function'

FunctionNode.define({
  parent: { type: 'id', optional: true },
  name: 'string',
  params: { type: ['array', 'object'], default: [] }, // [{name: 'doc', type: 'model/Document', description: 'A Substance document instance'}]
  returns: { type: 'object', optional: true }, // {type: 'model/Document', description: 'The updated document'}
})

FunctionNode.isBlock = true

const MEMBER_CATEGORIES$2 = {
  'ctor': {name: 'ctor', path: ['class', 'ctor']},
  'instance-methods': {name: 'instance-methods', path: ['instance', 'method']},
  'instance-properties': {name: 'instance-properties', path: ['instance', 'property']},
  'instance-events': {name: 'instance-events', path: ['instance', 'event']},
  'class-methods': {name: 'class-methods', path: ['class', 'method']},
  'class-properties': {name: 'class-properties', path: ['class', 'property']},
}

// var INHERITED = ['instance-methods', 'instance-properties', 'class-methods', 'class-properties']
const INHERITED = ['instance-methods', 'instance-properties']

class ClassNode extends APINode {

  getName() {
    return this.name
  }

  getSpecificType() {
    if (this.isAbstract) return 'abstract-class'
    return 'class'
  }

  getMemberCategories() {
    return MEMBER_CATEGORIES$2
  }

  getInheritedMembers(config) {
    var inheritedMembers = {}
    var doc = this.getDocument()
    var superClass = this.superClass ? doc.get(this.superClass) : null
    if (superClass) {
      inheritedMembers = superClass.getInheritedMembers(config)
      INHERITED.forEach(function(group) {
        var members = superClass.getCategoryMembers(MEMBER_CATEGORIES$2[group], config)
        if (members.length > 0) {
          inheritedMembers[group] = inheritedMembers[group] || {}
          members.forEach(function(member) {
            inheritedMembers[group][member.id] = member
          })
        }
      })
    }
    return inheritedMembers
  }

}

Object.assign(ClassNode.prototype, MemberContainerMixin)

ClassNode.type = 'class'
ClassNode.define({
  parent: { type: 'id', optional: true },
  name: 'string',
  members: { type: ['array', 'id'], default: [] },
  isAbstract: { type: 'boolean', default: false },
  superClass: { type: 'id', optional: true }
})

ClassNode.isBlock = true

var _createFind = createCommonjsModule(function (module) {
var baseIteratee = interopDefault(require$$5),
    isArrayLike = interopDefault(require$$2$12),
    keys = interopDefault(require$$0$18);

/**
 * Creates a `_.find` or `_.findLast` function.
 *
 * @private
 * @param {Function} findIndexFunc The function to find the collection index.
 * @returns {Function} Returns the new find function.
 */
function createFind(findIndexFunc) {
  return function(collection, predicate, fromIndex) {
    var iterable = Object(collection);
    if (!isArrayLike(collection)) {
      var iteratee = baseIteratee(predicate, 3);
      collection = keys(collection);
      predicate = function(key) { return iteratee(iterable[key], key, iterable); };
    }
    var index = findIndexFunc(collection, predicate, fromIndex);
    return index > -1 ? iterable[iteratee ? collection[index] : index] : undefined;
  };
}

module.exports = createFind;
});

var _createFind$1 = interopDefault(_createFind);


var require$$1$25 = Object.freeze({
	default: _createFind$1
});

var _baseFindIndex = createCommonjsModule(function (module) {
/**
 * The base implementation of `_.findIndex` and `_.findLastIndex` without
 * support for iteratee shorthands.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {Function} predicate The function invoked per iteration.
 * @param {number} fromIndex The index to search from.
 * @param {boolean} [fromRight] Specify iterating from right to left.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function baseFindIndex(array, predicate, fromIndex, fromRight) {
  var length = array.length,
      index = fromIndex + (fromRight ? 1 : -1);

  while ((fromRight ? index-- : ++index < length)) {
    if (predicate(array[index], index, array)) {
      return index;
    }
  }
  return -1;
}

module.exports = baseFindIndex;
});

var _baseFindIndex$1 = interopDefault(_baseFindIndex);


var require$$2$20 = Object.freeze({
	default: _baseFindIndex$1
});

var toNumber = createCommonjsModule(function (module) {
var isObject = interopDefault(require$$0$4),
    isSymbol = interopDefault(require$$0$32);

/** Used as references for various `Number` constants. */
var NAN = 0 / 0;

/** Used to match leading and trailing whitespace. */
var reTrim = /^\s+|\s+$/g;

/** Used to detect bad signed hexadecimal string values. */
var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;

/** Used to detect binary string values. */
var reIsBinary = /^0b[01]+$/i;

/** Used to detect octal string values. */
var reIsOctal = /^0o[0-7]+$/i;

/** Built-in method references without a dependency on `root`. */
var freeParseInt = parseInt;

/**
 * Converts `value` to a number.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to process.
 * @returns {number} Returns the number.
 * @example
 *
 * _.toNumber(3.2);
 * // => 3.2
 *
 * _.toNumber(Number.MIN_VALUE);
 * // => 5e-324
 *
 * _.toNumber(Infinity);
 * // => Infinity
 *
 * _.toNumber('3.2');
 * // => 3.2
 */
function toNumber(value) {
  if (typeof value == 'number') {
    return value;
  }
  if (isSymbol(value)) {
    return NAN;
  }
  if (isObject(value)) {
    var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
    value = isObject(other) ? (other + '') : other;
  }
  if (typeof value != 'string') {
    return value === 0 ? value : +value;
  }
  value = value.replace(reTrim, '');
  var isBinary = reIsBinary.test(value);
  return (isBinary || reIsOctal.test(value))
    ? freeParseInt(value.slice(2), isBinary ? 2 : 8)
    : (reIsBadHex.test(value) ? NAN : +value);
}

module.exports = toNumber;
});

var toNumber$1 = interopDefault(toNumber);


var require$$0$43 = Object.freeze({
	default: toNumber$1
});

var toFinite = createCommonjsModule(function (module) {
var toNumber = interopDefault(require$$0$43);

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0,
    MAX_INTEGER = 1.7976931348623157e+308;

/**
 * Converts `value` to a finite number.
 *
 * @static
 * @memberOf _
 * @since 4.12.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {number} Returns the converted number.
 * @example
 *
 * _.toFinite(3.2);
 * // => 3.2
 *
 * _.toFinite(Number.MIN_VALUE);
 * // => 5e-324
 *
 * _.toFinite(Infinity);
 * // => 1.7976931348623157e+308
 *
 * _.toFinite('3.2');
 * // => 3.2
 */
function toFinite(value) {
  if (!value) {
    return value === 0 ? value : 0;
  }
  value = toNumber(value);
  if (value === INFINITY || value === -INFINITY) {
    var sign = (value < 0 ? -1 : 1);
    return sign * MAX_INTEGER;
  }
  return value === value ? value : 0;
}

module.exports = toFinite;
});

var toFinite$1 = interopDefault(toFinite);


var require$$0$42 = Object.freeze({
	default: toFinite$1
});

var toInteger = createCommonjsModule(function (module) {
var toFinite = interopDefault(require$$0$42);

/**
 * Converts `value` to an integer.
 *
 * **Note:** This method is loosely based on
 * [`ToInteger`](http://www.ecma-international.org/ecma-262/7.0/#sec-tointeger).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {number} Returns the converted integer.
 * @example
 *
 * _.toInteger(3.2);
 * // => 3
 *
 * _.toInteger(Number.MIN_VALUE);
 * // => 0
 *
 * _.toInteger(Infinity);
 * // => 1.7976931348623157e+308
 *
 * _.toInteger('3.2');
 * // => 3
 */
function toInteger(value) {
  var result = toFinite(value),
      remainder = result % 1;

  return result === result ? (remainder ? result - remainder : result) : 0;
}

module.exports = toInteger;
});

var toInteger$1 = interopDefault(toInteger);


var require$$0$41 = Object.freeze({
	default: toInteger$1
});

var findIndex = createCommonjsModule(function (module) {
var baseFindIndex = interopDefault(require$$2$20),
    baseIteratee = interopDefault(require$$5),
    toInteger = interopDefault(require$$0$41);

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMax = Math.max;

/**
 * This method is like `_.find` except that it returns the index of the first
 * element `predicate` returns truthy for instead of the element itself.
 *
 * @static
 * @memberOf _
 * @since 1.1.0
 * @category Array
 * @param {Array} array The array to inspect.
 * @param {Function} [predicate=_.identity]
 *  The function invoked per iteration.
 * @param {number} [fromIndex=0] The index to search from.
 * @returns {number} Returns the index of the found element, else `-1`.
 * @example
 *
 * var users = [
 *   { 'user': 'barney',  'active': false },
 *   { 'user': 'fred',    'active': false },
 *   { 'user': 'pebbles', 'active': true }
 * ];
 *
 * _.findIndex(users, function(o) { return o.user == 'barney'; });
 * // => 0
 *
 * // The `_.matches` iteratee shorthand.
 * _.findIndex(users, { 'user': 'fred', 'active': false });
 * // => 1
 *
 * // The `_.matchesProperty` iteratee shorthand.
 * _.findIndex(users, ['active', false]);
 * // => 0
 *
 * // The `_.property` iteratee shorthand.
 * _.findIndex(users, 'active');
 * // => 2
 */
function findIndex(array, predicate, fromIndex) {
  var length = array ? array.length : 0;
  if (!length) {
    return -1;
  }
  var index = fromIndex == null ? 0 : toInteger(fromIndex);
  if (index < 0) {
    index = nativeMax(length + index, 0);
  }
  return baseFindIndex(array, baseIteratee(predicate, 3), index);
}

module.exports = findIndex;
});

var findIndex$1 = interopDefault(findIndex);


var require$$0$40 = Object.freeze({
	default: findIndex$1
});

var find = createCommonjsModule(function (module) {
var createFind = interopDefault(require$$1$25),
    findIndex = interopDefault(require$$0$40);

/**
 * Iterates over elements of `collection`, returning the first element
 * `predicate` returns truthy for. The predicate is invoked with three
 * arguments: (value, index|key, collection).
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Collection
 * @param {Array|Object} collection The collection to inspect.
 * @param {Function} [predicate=_.identity]
 *  The function invoked per iteration.
 * @param {number} [fromIndex=0] The index to search from.
 * @returns {*} Returns the matched element, else `undefined`.
 * @example
 *
 * var users = [
 *   { 'user': 'barney',  'age': 36, 'active': true },
 *   { 'user': 'fred',    'age': 40, 'active': false },
 *   { 'user': 'pebbles', 'age': 1,  'active': true }
 * ];
 *
 * _.find(users, function(o) { return o.age < 40; });
 * // => object for 'barney'
 *
 * // The `_.matches` iteratee shorthand.
 * _.find(users, { 'age': 1, 'active': true });
 * // => object for 'pebbles'
 *
 * // The `_.matchesProperty` iteratee shorthand.
 * _.find(users, ['active', false]);
 * // => object for 'fred'
 *
 * // The `_.property` iteratee shorthand.
 * _.find(users, 'active');
 * // => object for 'barney'
 */
var find = createFind(findIndex);

module.exports = find;
});

class SubstanceClassNode extends ClassNode {
  // Defaults to the regular type property
  getSpecificType() {
    var isComponent = this.hasTag('component')
    if (isComponent) {
      return this.isAbstract ? 'abstract-component': 'component'
    } else {
      return super.getSpecificType()
    }
  }
}

class ConstructorNode extends APINode {}

// ATTENTION: we have to use 'ctor' has constructor is a key property of
// every object
ConstructorNode.type = 'ctor';

ConstructorNode.define({
  parent: 'id', // id of parent class or module
  name: 'string',
  params: { type: ['array', 'object'], default: [] },
  isPrivate: { type: 'boolean', default: false },
});

class MethodNode extends APINode {
  getParent() {
    return this.getDocument().get(this.parent)
  }
}

MethodNode.type = 'method'

MethodNode.define({
  parent: 'id', // id of parent class or module
  name: 'string',
  params: { type: ['array', 'object'], default: [] }, // [{name: 'doc', type: 'model/Document', description: 'A Substance document instance'}]
  returns: { type: 'object', optional: true }, // {type: 'model/Document', description: 'The updated document'}
  isStatic: { type: 'boolean', default: false },
  isPrivate: { type: 'boolean', default: false },
})

class PropertyNode extends APINode {
  getParent() {
    return this.getDocument().get(this.parent)
  }
}

PropertyNode.type = 'property'

PropertyNode.define({
  parent: 'id', // id of parent class or module
  name: 'string',
  dataType: { type: 'string', optional: true },
  isStatic: { type: 'boolean', default: false },
})

class EventNode extends APINode {}

EventNode.type = 'event'

EventNode.define({
  parent: 'id',
  name: 'string',
  params: { type: ['array', 'object'], default: [] } // [{name: 'doc', type: 'model/Document', description: 'A Substance document instance'}]
})

EventNode.isBlock = true

var DocumentationPackage = {
  name: 'documentation-model',
  configure: function(config) {
    config.defineSchema({
      name: 'documentation',
      ArticleClass: Documentation,
      defaultTextType: 'paragraph'
    })
    config.addNode(Page)
    config.addNode(APIPage)
    config.addNode(Section)
    config.addNode(FileNode)
    config.addNode(ModuleNode)
    config.addNode(FunctionNode)
    config.addNode(SubstanceClassNode)
    config.addNode(ConstructorNode)
    config.addNode(MethodNode)
    config.addNode(PropertyNode)
    config.addNode(EventNode)
  }
}

class LinkProvider {
  constructor(doc) {
    this.doc = doc
  }
  getURL(id, hints) {
    const lookupTable = doc.getIndex('id-lookup')
    const _id = lookupTable.lookupId(id, hints)
    if (_id) id = _id
    return "#"+ id
  }
}

class Documentation extends substance.Document {
  constructor(data) {
    super(getSchema())

    this.title = data.title || ''
    this.repository = data.repository || ''
    this.sha = data.sha || ''
    this.defaultPage = data.defaultPage || 'about'

    this.create({
      type: 'container',
      id: 'pages'
    })

    this.addIndex('id-lookup', new LookupTable(this))
    this.addIndex('members', new MemberIndex(this))

    this.linkProvider = new LinkProvider(this)
  }
  getPages() {
    const _pages = this.get('pages')
    if (!_pages) return []
    return _pages.getNodes()
  }
  getDefaultPage() {
    return this.get(this.defaultPage)
  }
  getClasses(config) {
    return this._getByType('class', config)
  }
  getModules(config) {
    return this._getByType('module', config)
  }
  getAPIGroups(config) {
    const groups = {
      "class": [],
      "component": [],
      "module": []
    }
    const classes = this.getClasses(config)
    classes.forEach(function(clazz) {
      if (clazz.hasTag('component')) {
        groups['component'].push(clazz)
      } else {
        groups['class'].push(clazz)
      }
    })
    groups['module'] = this.getModules(config)
    return groups
  }
  _getByType(type, config) {
    let items = map$1(this.getIndex('type').get(type))
    if (config.skipPrivate || config.skipAbstract || config.skipInternal) {
      items = items.filter(function(item) {
        if (config.skipAbstract && item.isAbstract) return false
        if (config.skipPrivate && item.hasTag('private')) return false
        if (config.skipInternal && item.hasTag('internal')) return false
        if (item.isUndocumented) return false
        return true
      })
    }
    items.sort(function(a, b) {
      if (a.name<b.name) return -1
      if (a.name>b.name) return 1
      return 0
    })
    return items
  }

  prepareHTML(html, hints) {
    html = html || ''
    const linkRe = /\{@link\s+([^}]+)\s*\}/g
    let chunks = []
    let match, lastIdx = 0
    while ((match = linkRe.exec(html))) {
      const start = match.index
      const end = start + match[0].length
      const id = match[1]
      const url = this.linkProvider.getURL(id, hints)
      chunks.push(html.slice(lastIdx, start))
      chunks = chunks.concat('<a href="', url, '">', id, '</a>')
      lastIdx = end
    }
    chunks.push(html.slice(lastIdx))
    return chunks.join('')
  }
}

Documentation.getNodeInfo = function(node) {
  var info = {
    isClassMember: false,
    isModuleMember: false,
    isConstructor: false,
    storage: '',
    typeDescr: ''
  }

  var hasParent = node.hasParent()
  var parent
  if (hasParent) {
    parent = node.getParent()
    info.isClassMember = (parent.type === 'class')
    info.isModuleMember = (parent.type === 'module')
  }

  if (node.type === 'ctor') {
    info.isConstructor = true
  }

  // Derive storage
  if (info.isConstructor) {
    info.storage = 'new '
  } else if (info.isClassMember && !node.isStatic) {
    info.storage = 'this.'
  } else if (info.isModuleMember) {
    info.storage = parent.name + '.'
  }

  // Derive typeDescr
  if (info.isConstructor) {
    info.typeDescr = 'Constructor'
  } else if (info.isClassMember || info.isModuleMember) {
    if (node.isStatic) {
      info.typeDescr = 'Static Method'
    } else {
      info.typeDescr = 'Method'
    }
  }
  return info
}

function getSchema() {
  const config = new substance.Configurator()
  config.import(DocumentationPackage)
  return config.getSchema()
}

class DocumentationRouter extends substance.Router {

  constructor(controller) {
    super()

    this.controller = controller
  }

  parseRoute(route) {
    if (!route) {
      return this.controller.getInitialState()
    } else {
      // var nodeId = route
      return {
        nodeId: route
      }
    }
  }

  stringifyRoute() {
    return this.controller.state.nodeId
  }

}

class Navbar extends substance.Component {
  render($$) {
    const pages = this.props.pages
    const linkProvider = this.context.linkProvider
    const el = $$('div').addClass('sc-navbar')

    const title = $$('div').addClass('se-title').append(
      $$('a').attr('href', linkProvider.getURL('about')).append(this.props.title)
    )
    el.append(title)

    const pagesEl = $$('div').addClass('se-pages')
    pages.forEach((page) => {
      const pageEl = $$('a')
        .attr('href', linkProvider.getURL(page.id))
        .addClass('se-page')
        .text(page.getTitle())
      pagesEl.append(pageEl)
    })
    el.append(pagesEl)

    return el
  }
}

const order = [
  { type: 'class', label: 'classes' },
  { type: 'component', label: 'components' },
  { type: 'module', label: 'modules' },
]

class ApiTOC extends substance.Component {

  render($$) {
    const el = $$('div').addClass(this._getClasses())
    const node = this.props.node
    const doc = node.getDocument()
    const groups = doc.getAPIGroups(this.context.config)
    order.forEach((cat) => {
      el.append(
        this._renderCategory($$, cat, groups[cat.type])
      )
    })
    return el
  }

  _getClasses() {
    return 'sc-api-toc'
  }

  _renderCategory($$, category, items) {
    const catEl = $$('div').addClass('se-category')
    // label
    const label = $$('div').addClass('se-label').text(this.getLabel(category.label))
    catEl.append(label)
    if (items.length === 0) return null
    const itemsContainer = $$('div').addClass('se-items')
    items.forEach((item) => {
      itemsContainer.append(this._renderItem($$, item))
    })
    catEl.append(itemsContainer)

    return catEl
  }

  _renderItem($$, item) {
    const linkProvider = this.context.linkProvider
    return $$('a')
      .attr('href', linkProvider.getURL(item.id))
      .addClass('se-item')
      .text(item.name)
  }

}

ApiTOC.order = order

class PageTOC extends substance.Component {

  render($$) {
    const node = this.props.node
    const linkProvider = this.context.linkProvider
    const el = $$('div').addClass('sc-page-toc')
    const titleEl = $$('a').addClass('se-title')
      .attr('href', linkProvider.getURL(node.id))
      .text(node.getTitle())
      .on('click', this._onClickItem.bind(this, node))

    const sectionsEl = $$('div').addClass('se-sections')
    node.getSections().forEach((sec) => {
      sectionsEl.append(
        this._renderSection($$, sec)
      )
    })
    el.append(titleEl)
    el.append(sectionsEl)
    return el
  }

  _renderSection($$, sec) {
    const linkProvider = this.context.linkProvider
    const secEl = $$('a').addClass('se-section')
      .attr('href', linkProvider.getURL(sec.id))
      .text(this.getLabel(sec.getTitle()))
      .on('click', this._onClickItem.bind(this, sec))
    return secEl
  }

  _onClickItem(node, evt) {
    evt.stopPropagation()
  }

}

class DocumentationReader extends substance.Component {

  constructor(...args) {
    super(...args)
    this._initialize(this.props)
    this.handleActions({
      'switchState': this.switchState,
      'extendState': this.extendState,
      'tocEntrySelected': this.focusNode,
      'focusNode': this.focusNode
    })
  }

  _initialize(props) {
    var configurator = props.configurator

    this.config = DocumentationReader.config
    this.router = new DocumentationRouter(this)
    this.router.on('route:changed', this._onRouteChanged, this)
    this.componentRegistry = configurator.getComponentRegistry()
    this.iconProvider = configurator.getIconProvider()
    this.labelProvider = configurator.getLabelProvider()
    this.idProvider = this.props.idProvider
  }

  getChildContext() {
    return {
      doc: this.getDocument(),
      config: this.config,
      tocProvider: this.tocProvider,
      componentRegistry: this.componentRegistry,
      iconProvider: this.iconProvider,
      labelProvider: this.labelProvider,
      linkProvider: this.getDocument().linkProvider,
      idProvider: this.idProvider
    }
  }

  // this increases rerendering speed alot.
  // A deep rerender takes quite a time (about 400ms) because of the many components.
  // We can do this as long the content is not changed depending on the state
  // -- just updating scroll position ATM.
  // shouldRerender() {
  //   return false
  // }

  dispose() {
    this.router.dispose()
  }

  didMount() {
    var route = this.router.readRoute()
    // Replaces the current entry without creating new history entry
    // or triggering hashchange
    this.navigate(route, {replace: true})
    this._updateScrollPosition()
  }

  didUpdate() {
    this._updateScrollPosition()
  }

  render($$) {
    const el =$$('div').addClass('sc-documentation-reader sc-controller')
    el.append(
      this._renderNavBar($$),
      $$('div').addClass('se-page-content').append(
        this._renderTOC($$),
        this._renderMainSection($$)
      )
    )
    return el
  }

  _renderNavBar($$) {
    return $$(Navbar, { title: this._getTitle(), pages: this._getPages() })
  }

  _renderTOC($$) {
    const el = $$('div')
      .addClass('se-context-section')
      .ref('contextSection')

    const content = this._getContent()
    let TOCComponent
    let page
    if (content) {
      switch (content.type) {
        case 'page':
          TOCComponent = PageTOC
          page = content
          break
        case 'section':
          TOCComponent = PageTOC
          page = content.getPage()
          break
        case 'api-page':
          TOCComponent = ApiTOC
          page = content
          break
        case 'module':
        case 'class':
        case 'method':
        case 'property':
        case 'function':
        case 'ctor':
          TOCComponent = ApiTOC
          page = content.getAPIPage()
          break
        default:
          //
      }
    }
    if (TOCComponent) {
      el.append($$(TOCComponent, { doc: this.props.doc, node: page }))
    }
    return el
  }

  _renderMainSection($$) {
    const main = $$('div').ref('main').addClass('se-main-section')

    let ContentRenderer
    let content = this._getContent()
    if (content) {
      switch (content.type) {
        case 'method':
        case 'property':
        case 'function':
        case 'ctor':
          content = content.getParent()
          break
        default:
          //
      }
      ContentRenderer = this.getComponent(content.type)
      main.append(
        $$(ContentRenderer, { node: content }).ref('content')
      )
    }

    return main
  }

  getComponentRegistry() {
    return this.componentRegistry
  }

  getDocument() {
    return this.props.doc
  }

  _getContent() {
    const doc = this.getDocument()
    if (this.state.nodeId) {
      return doc.get(this.state.nodeId)
    } else {
      return doc.getDefaultPage()
    }
  }

  _getPages() {
    return this.getDocument().getPages()
  }

  _getTitle() {
    return this.getDocument().title
  }

  navigate(route, opts) {
    this.extendState(route)
    this.router.writeRoute(route, opts)
  }

  _onRouteChanged(route) {
    this.navigate(route, {replace: true})
  }

  focusNode(nodeId) {
    this.navigate({
      nodeId: nodeId
    })
  }

  switchState(newState) {
    this.navigate(newState)
  }

  _updateScrollPosition() {
    if (substance.inBrowser && this.refs.contentPanel && this.state.nodeId) {
      this.refs.contentPanel.scrollTo(this.state.nodeId, true)
    }
  }
}

// TODO: we should move this into a DocumentationConfigurator API
DocumentationReader.config = {
  skipAbstract: false,
  skipPrivate: true,
  skipInternal: true,
}

class ContentComponent extends substance.Component {

  render($$) {
    const node = this.props.node
    const doc = node.getDocument()
    const el = $$('div')
      .addClass('sc-content')
      .attr("data-id", node.id)
    el.append(
      $$('div').addClass('se-title').append(node.title),
      $$('div').addClass('se-description').html(doc.prepareHTML(node.description))
    )
    return el
  }

}

var each = createCommonjsModule(function (module) {
module.exports = interopDefault(require$$0$39);
});

var forEach$2 = interopDefault(each);

class MemberContainerComponent extends substance.Component {

  _renderMembers($$) {
    var node = this.props.node
    var el = $$('div')
    forEach$2(node.getMemberCategories(), function(cat) {
      var catMembers = this._getCategoryMembers(cat)
      if (catMembers.length > 0) {
        el.append(this._renderMemberCategory($$, cat, catMembers))
      }
    }.bind(this))
    return el.children
  }

  _renderMemberCategory($$, cat, catMembers) {
    var catEl = $$('div').addClass('se-member-category')
    var membersEl = $$('div').addClass('se-members')
    // Note: using lodash each, so that we are independent
    // of catMembers being an array or an object.
    forEach$2(catMembers, function(memberNode) {
      membersEl.append(this._renderMember($$, memberNode))
    }.bind(this))
    catEl.append(membersEl)
    return catEl
  }

  _renderMember($$, memberNode) {
    var node = this.props.node
    var doc = node.getDocument()
    var componentRegistry = this.context.componentRegistry
    var ComponentClass = componentRegistry.get(memberNode.type)
    if (!ComponentClass) {
      console.error('Could not resolve a component for type: ' + node.type)
      ComponentClass = substance.UnsupportedNodeComponent
    }
    return $$(ComponentClass, {
      doc: doc,
      node: memberNode,
      parentNode: node
    })
  }

  _getCategoryMembers(cat) {
    var config = this.context.config
    var node = this.props.node
    return node.getCategoryMembers(cat, config)
  }

}

class SourceLinkComponent extends substance.Component {

  render($$) {
    var node = this.props.node
    var el = $$('a').addClass('sc-source-link')
      .attr({href: '#', target:'_blank', "data-source-file": node.sourceFile, "data-source-line": node.sourceLine})
      .append(node.sourceFile+"#"+node.sourceLine)
    // TODO: make this configurable
    el.attr('href', this.getGithubUrl())
    return el
  }

  getGithubUrl() {
    const node = this.props.node
    const doc = node.getDocument()
    var githubUrl = doc.repository + "/blob/" + doc.sha + "/" + node.sourceFile + "#L" + node.sourceLine
    return githubUrl
  }
}

const LBRACKET = '['.charCodeAt(0)

class SignatureComponent extends substance.Component {

  render($$) {
    const node = this.props.node
    const linkProvider = this.context.linkProvider
    const el = $$('div').addClass('sc-signature')

    var params = node.params
    var info = Documentation.getNodeInfo(node)
    var visibility = node.isPrivate ? 'private ' : ''
    var args = params.map(function(param) {
      let name = param.name
      // HACK: skip options parameters here
      if (name.indexOf('.')>0) return null
      // HACK: removing brackets
      if (name.charCodeAt(0) === LBRACKET) {
        name = name.slice(1, name.length-1)
      }
      return name
    }).filter(Boolean).join(', ')

    const decl = $$('a').addClass('se-declaration')
      .attr('href', linkProvider.getURL(node.id))

    if (node.isPrivate) {
      decl.append($$('span').addClass('se-visibility').append(visibility))
    }
    decl.append($$('span').addClass('se-storage').append(info.storage))

    if (node.isStatic) {
      const parentName = node.getParent().name
      decl.append($$('span').addClass('se-parent').text(parentName))
        .append('.')
    }

    decl.append($$('span').addClass('se-name').text(node.name))
      .append('(')
      .append($$('span').addClass('se-arguments').append(args))
      .append(')')

    el.append(decl)

    if (!this.props.short) {
      el.append(
        $$('div').addClass('se-source').append(
          $$('strong').append(info.typeDescr),
          $$('span').append(' defined in '),
          $$(SourceLinkComponent, {node: node})
        )
      )
    }

    return el
  }

}

class APIPageComponent extends ApiTOC {

  render($$) {
    const el = $$('div').addClass(this._getClasses())
    const node = this.props.node
    const doc = node.getDocument()
    const groups = doc.getAPIGroups(this.context.config)

    el.append(
      $$('div').addClass('se-description').html(doc.prepareHTML(node.description))
    )

    const indexEl = $$('div').addClass('se-index')

    ApiTOC.order.forEach((cat) => {
      indexEl.append(
        this._renderCategory($$, cat, groups[cat.type])
      )
    })

    el.append(indexEl)
    return el
  }

  _getClasses() {
    return 'sc-api-page'
  }

  // this renders one of the major categories as displayed in the ApiTOC
  _renderItem($$, item) {
    const linkProvider = this.context.linkProvider
    const itemEl = $$('div').addClass('se-item')
    itemEl.append(
      $$('a')
        .attr('href', linkProvider.getURL(item.id))
        .addClass('se-label')
        .text(item.name)
    )
    itemEl.append($$(Members, {node: item}))
    return itemEl
  }

}

class Members extends MemberContainerComponent {
  render($$) {
    const node = this.props.node
    const el = $$('div')
      .addClass('se-members se-'+node.type)
    if (node.members && node.members.length > 0) {
      el.append(this._renderMembers($$))
    }
    return el
  }

  _renderMember($$, member) {
    const linkProvider = this.context.linkProvider
    let name = member.name
    const el = $$('div').addClass('se-member').addClass('se-'+member.type)
    switch(member.type) {
      case 'function':
      case 'method':
      case 'ctor':
        el.append($$(SignatureComponent, {node: member, short: true}))
        break
      default:
        el.append($$('a')
          .attr('href', linkProvider.getURL(member.id))
          .text(name)
        )
    }
    return el
  }
}

class FileComponent extends MemberContainerComponent {

  render($$) {
    const node = this.props.node
    const el = $$('div')
      .addClass('sc-file')
      .attr("data-id", node.id)
    // members
    if (node.members && node.members.length > 0) {
      // members
      el.append(this._renderMembers($$))
    }
    return el
  }

}

class CrossLinkComponent extends substance.Component {

  render($$) {
    const node = this.props.node
    const linkProvider = this.context.linkProvider
    var el
    if (node) {
      el = $$('a').addClass('sc-cross-link')
        .attr({
          href: linkProvider.getURL(node.id),
          "data-type": 'cross-link',
          "data-node-id": node.id
        })
    } else {
      el = $$('span')
    }
    if (this.props.children.length > 0) {
      el.append(this.props.children)
    }
    return el
  }
}

class HeadingComponent extends substance.Component {

  render($$) {
    var node = this.props.node
    var doc = node.getDocument()

    var name = node.name
    var type = node.type
    var specificType = node.getSpecificType()
    var el = $$('div').addClass('sc-doc-heading')
    var headerEl = $$('div').addClass('se-header')

    // name
    headerEl.append(
      $$('span').addClass('se-name').append(this.props.name || name)
    )
    // details: a line saying something like Class defined in '...', extends '...'
    var details = $$('div').addClass('se-details').addClass(type)
    var detailsLabel = $$('strong').addClass('se-type')
    detailsLabel.append(this.getLabel(specificType))
    details.append(detailsLabel)

    details.append(
      $$('span').addClass('se-source').append(
        $$('span').append(' ' + this.getLabel('defined-in') + ' '),
        $$(SourceLinkComponent, {node: node})
      )
    )
    if (node.type === "class" && node.superClass) {
      var superClassNode = doc.get(node.superClass)
      details.append(
        $$('span').addClass('se-extends').append(
          $$('span').append(' ' + this.getLabel('extends') + ' '),
          $$(CrossLinkComponent, {node: superClassNode})
        )
      )
    }
    el.append(headerEl, details)

    return el
  }

}

class ParamsComponent extends substance.Component {

  render($$) {
    var doc = this.context.doc
    var el = $$('div').addClass('sc-params')
    var params = this.props.params
    var returns = this.props.returns

    if (params.length > 0) {
      el.append($$('div').addClass('se-label').append(this.getLabel(this.props.label || 'parameters')))

      var paramsTable = $$('table').addClass('se-params-table')
      params.forEach(function(param) {
        var typeNode
        if (param.type) {
          typeNode = doc.get(param.type)
        }
        paramsTable.append(
          $$('tr').addClass('se-param').append(
            $$('td').addClass('se-param-name').append(param.name),
            $$('td').addClass('se-param-type').append(
              $$(CrossLinkComponent, {node: typeNode}).append(param.shortType)
            ),
            $$('td').addClass('se-param-description').html(param.description)
          )
        )
      })
      el.append(paramsTable)
    }
    if (returns) {
      var returnTypeNode
      if (returns.type) {
        returnTypeNode = doc.get(returns.type)
      }
      el.append($$('div').addClass('se-returns se-label').append(this.getLabel('returns')))
      el.append(
        $$('table').addClass('se-params-table').append(
          $$('tr').addClass('se-param').append(
            $$('td').addClass('se-param-type').append(
              $$(CrossLinkComponent, {node: returnTypeNode}).append(returns.type)
            ),
            $$('td').addClass('se-param-description').html(returns.description)
          )
        )
      )
    }
    return el
  }
}

class ExampleComponent extends substance.Component {

  render($$) {
    const node = this.props.node
    const doc = node.getDocument()
    const el = $$('div').addClass('sc-example').append(
      $$('div').addClass('se-heading').append(this.getLabel('example'))
    )
    const body = $$('div').addClass('se-body')
    body.append($$('div').addClass('se-description').html(doc.prepareHTML(node.example)))
    el.append(body)

    return el
  }

}

class FunctionComponent extends substance.Component {

  render($$) {
    const node = this.props.node
    const doc = node.getDocument()
    const idProvider = this.context.idProvider
    const el = $$('div')
      .addClass('sc-function')
      .attr("data-id", node.id)
    if (idProvider) el.attr('id', idProvider.getId(node))

    // heading
    const args = map$1(node.params, 'name').join(', ')
    const headingName = [node.name, '(', args, ')']
    el.append($$(HeadingComponent, {node: node, name: headingName}))

    // description
    el.append($$('div').addClass('se-description').html(doc.prepareHTML(node.description)))

    // params
    if (node.params.length > 0 || node.returns) {
      el.append($$(ParamsComponent, {params: node.params, returns: node.returns}))
    }

    // example
    if (node.example) {
      el.append($$(ExampleComponent, {node: node}))
    }
    return el
  }

}

var _arrayPush = createCommonjsModule(function (module) {
/**
 * Appends the elements of `values` to `array`.
 *
 * @private
 * @param {Array} array The array to modify.
 * @param {Array} values The values to append.
 * @returns {Array} Returns `array`.
 */
function arrayPush(array, values) {
  var index = -1,
      length = values.length,
      offset = array.length;

  while (++index < length) {
    array[offset + index] = values[index];
  }
  return array;
}

module.exports = arrayPush;
});

var _arrayPush$1 = interopDefault(_arrayPush);


var require$$1$26 = Object.freeze({
	default: _arrayPush$1
});

var _isFlattenable = createCommonjsModule(function (module) {
var Symbol = interopDefault(require$$2$10),
    isArguments = interopDefault(require$$1$11),
    isArray = interopDefault(require$$0$21);

/** Built-in value references. */
var spreadableSymbol = Symbol ? Symbol.isConcatSpreadable : undefined;

/**
 * Checks if `value` is a flattenable `arguments` object or array.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is flattenable, else `false`.
 */
function isFlattenable(value) {
  return isArray(value) || isArguments(value) ||
    !!(spreadableSymbol && value && value[spreadableSymbol]);
}

module.exports = isFlattenable;
});

var _isFlattenable$1 = interopDefault(_isFlattenable);


var require$$0$44 = Object.freeze({
	default: _isFlattenable$1
});

var _baseFlatten = createCommonjsModule(function (module) {
var arrayPush = interopDefault(require$$1$26),
    isFlattenable = interopDefault(require$$0$44);

/**
 * The base implementation of `_.flatten` with support for restricting flattening.
 *
 * @private
 * @param {Array} array The array to flatten.
 * @param {number} depth The maximum recursion depth.
 * @param {boolean} [predicate=isFlattenable] The function invoked per iteration.
 * @param {boolean} [isStrict] Restrict to values that pass `predicate` checks.
 * @param {Array} [result=[]] The initial result value.
 * @returns {Array} Returns the new flattened array.
 */
function baseFlatten(array, depth, predicate, isStrict, result) {
  var index = -1,
      length = array.length;

  predicate || (predicate = isFlattenable);
  result || (result = []);

  while (++index < length) {
    var value = array[index];
    if (depth > 0 && predicate(value)) {
      if (depth > 1) {
        // Recursively flatten arrays (susceptible to call stack limits).
        baseFlatten(value, depth - 1, predicate, isStrict, result);
      } else {
        arrayPush(result, value);
      }
    } else if (!isStrict) {
      result[result.length] = value;
    }
  }
  return result;
}

module.exports = baseFlatten;
});

var _baseFlatten$1 = interopDefault(_baseFlatten);


var require$$3$12 = Object.freeze({
	default: _baseFlatten$1
});

var _baseSortBy = createCommonjsModule(function (module) {
/**
 * The base implementation of `_.sortBy` which uses `comparer` to define the
 * sort order of `array` and replaces criteria objects with their corresponding
 * values.
 *
 * @private
 * @param {Array} array The array to sort.
 * @param {Function} comparer The function to define sort order.
 * @returns {Array} Returns `array`.
 */
function baseSortBy(array, comparer) {
  var length = array.length;

  array.sort(comparer);
  while (length--) {
    array[length] = array[length].value;
  }
  return array;
}

module.exports = baseSortBy;
});

var _baseSortBy$1 = interopDefault(_baseSortBy);


var require$$3$13 = Object.freeze({
	default: _baseSortBy$1
});

var _compareAscending = createCommonjsModule(function (module) {
var isSymbol = interopDefault(require$$0$32);

/**
 * Compares values to sort them in ascending order.
 *
 * @private
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {number} Returns the sort order indicator for `value`.
 */
function compareAscending(value, other) {
  if (value !== other) {
    var valIsDefined = value !== undefined,
        valIsNull = value === null,
        valIsReflexive = value === value,
        valIsSymbol = isSymbol(value);

    var othIsDefined = other !== undefined,
        othIsNull = other === null,
        othIsReflexive = other === other,
        othIsSymbol = isSymbol(other);

    if ((!othIsNull && !othIsSymbol && !valIsSymbol && value > other) ||
        (valIsSymbol && othIsDefined && othIsReflexive && !othIsNull && !othIsSymbol) ||
        (valIsNull && othIsDefined && othIsReflexive) ||
        (!valIsDefined && othIsReflexive) ||
        !valIsReflexive) {
      return 1;
    }
    if ((!valIsNull && !valIsSymbol && !othIsSymbol && value < other) ||
        (othIsSymbol && valIsDefined && valIsReflexive && !valIsNull && !valIsSymbol) ||
        (othIsNull && valIsDefined && valIsReflexive) ||
        (!othIsDefined && valIsReflexive) ||
        !othIsReflexive) {
      return -1;
    }
  }
  return 0;
}

module.exports = compareAscending;
});

var _compareAscending$1 = interopDefault(_compareAscending);


var require$$0$45 = Object.freeze({
	default: _compareAscending$1
});

var _compareMultiple = createCommonjsModule(function (module) {
var compareAscending = interopDefault(require$$0$45);

/**
 * Used by `_.orderBy` to compare multiple properties of a value to another
 * and stable sort them.
 *
 * If `orders` is unspecified, all values are sorted in ascending order. Otherwise,
 * specify an order of "desc" for descending or "asc" for ascending sort order
 * of corresponding values.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {boolean[]|string[]} orders The order to sort by for each property.
 * @returns {number} Returns the sort order indicator for `object`.
 */
function compareMultiple(object, other, orders) {
  var index = -1,
      objCriteria = object.criteria,
      othCriteria = other.criteria,
      length = objCriteria.length,
      ordersLength = orders.length;

  while (++index < length) {
    var result = compareAscending(objCriteria[index], othCriteria[index]);
    if (result) {
      if (index >= ordersLength) {
        return result;
      }
      var order = orders[index];
      return result * (order == 'desc' ? -1 : 1);
    }
  }
  // Fixes an `Array#sort` bug in the JS engine embedded in Adobe applications
  // that causes it, under certain circumstances, to provide the same value for
  // `object` and `other`. See https://github.com/jashkenas/underscore/pull/1247
  // for more details.
  //
  // This also ensures a stable sort in V8 and other engines.
  // See https://bugs.chromium.org/p/v8/issues/detail?id=90 for more details.
  return object.index - other.index;
}

module.exports = compareMultiple;
});

var _compareMultiple$1 = interopDefault(_compareMultiple);


var require$$1$27 = Object.freeze({
	default: _compareMultiple$1
});

var _baseOrderBy = createCommonjsModule(function (module) {
var arrayMap = interopDefault(require$$6),
    baseIteratee = interopDefault(require$$5),
    baseMap = interopDefault(require$$4$9),
    baseSortBy = interopDefault(require$$3$13),
    baseUnary = interopDefault(require$$2$15),
    compareMultiple = interopDefault(require$$1$27),
    identity = interopDefault(require$$0$35);

/**
 * The base implementation of `_.orderBy` without param guards.
 *
 * @private
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function[]|Object[]|string[]} iteratees The iteratees to sort by.
 * @param {string[]} orders The sort orders of `iteratees`.
 * @returns {Array} Returns the new sorted array.
 */
function baseOrderBy(collection, iteratees, orders) {
  var index = -1;
  iteratees = arrayMap(iteratees.length ? iteratees : [identity], baseUnary(baseIteratee));

  var result = baseMap(collection, function(value, key, collection) {
    var criteria = arrayMap(iteratees, function(iteratee) {
      return iteratee(value);
    });
    return { 'criteria': criteria, 'index': ++index, 'value': value };
  });

  return baseSortBy(result, function(object, other) {
    return compareMultiple(object, other, orders);
  });
}

module.exports = baseOrderBy;
});

var _baseOrderBy$1 = interopDefault(_baseOrderBy);


var require$$2$21 = Object.freeze({
	default: _baseOrderBy$1
});

var _apply = createCommonjsModule(function (module) {
/**
 * A faster alternative to `Function#apply`, this function invokes `func`
 * with the `this` binding of `thisArg` and the arguments of `args`.
 *
 * @private
 * @param {Function} func The function to invoke.
 * @param {*} thisArg The `this` binding of `func`.
 * @param {Array} args The arguments to invoke `func` with.
 * @returns {*} Returns the result of `func`.
 */
function apply(func, thisArg, args) {
  switch (args.length) {
    case 0: return func.call(thisArg);
    case 1: return func.call(thisArg, args[0]);
    case 2: return func.call(thisArg, args[0], args[1]);
    case 3: return func.call(thisArg, args[0], args[1], args[2]);
  }
  return func.apply(thisArg, args);
}

module.exports = apply;
});

var _apply$1 = interopDefault(_apply);


var require$$0$46 = Object.freeze({
	default: _apply$1
});

var _overRest = createCommonjsModule(function (module) {
var apply = interopDefault(require$$0$46);

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMax = Math.max;

/**
 * A specialized version of `baseRest` which transforms the rest array.
 *
 * @private
 * @param {Function} func The function to apply a rest parameter to.
 * @param {number} [start=func.length-1] The start position of the rest parameter.
 * @param {Function} transform The rest array transform.
 * @returns {Function} Returns the new function.
 */
function overRest(func, start, transform) {
  start = nativeMax(start === undefined ? (func.length - 1) : start, 0);
  return function() {
    var args = arguments,
        index = -1,
        length = nativeMax(args.length - start, 0),
        array = Array(length);

    while (++index < length) {
      array[index] = args[start + index];
    }
    index = -1;
    var otherArgs = Array(start + 1);
    while (++index < start) {
      otherArgs[index] = args[index];
    }
    otherArgs[start] = transform(array);
    return apply(func, this, otherArgs);
  };
}

module.exports = overRest;
});

var _overRest$1 = interopDefault(_overRest);


var require$$1$29 = Object.freeze({
	default: _overRest$1
});

var constant = createCommonjsModule(function (module) {
/**
 * Creates a function that returns `value`.
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Util
 * @param {*} value The value to return from the new function.
 * @returns {Function} Returns the new constant function.
 * @example
 *
 * var objects = _.times(2, _.constant({ 'a': 1 }));
 *
 * console.log(objects);
 * // => [{ 'a': 1 }, { 'a': 1 }]
 *
 * console.log(objects[0] === objects[1]);
 * // => true
 */
function constant(value) {
  return function() {
    return value;
  };
}

module.exports = constant;
});

var constant$1 = interopDefault(constant);


var require$$2$22 = Object.freeze({
	default: constant$1
});

var _defineProperty = createCommonjsModule(function (module) {
var getNative = interopDefault(require$$0$3);

var defineProperty = (function() {
  try {
    var func = getNative(Object, 'defineProperty');
    func({}, '', {});
    return func;
  } catch (e) {}
}());

module.exports = defineProperty;
});

var _defineProperty$1 = interopDefault(_defineProperty);


var require$$1$31 = Object.freeze({
	default: _defineProperty$1
});

var _baseSetToString = createCommonjsModule(function (module) {
var constant = interopDefault(require$$2$22),
    defineProperty = interopDefault(require$$1$31),
    identity = interopDefault(require$$0$35);

/**
 * The base implementation of `setToString` without support for hot loop shorting.
 *
 * @private
 * @param {Function} func The function to modify.
 * @param {Function} string The `toString` result.
 * @returns {Function} Returns `func`.
 */
var baseSetToString = !defineProperty ? identity : function(func, string) {
  return defineProperty(func, 'toString', {
    'configurable': true,
    'enumerable': false,
    'value': constant(string),
    'writable': true
  });
};

module.exports = baseSetToString;
});

var _baseSetToString$1 = interopDefault(_baseSetToString);


var require$$1$30 = Object.freeze({
	default: _baseSetToString$1
});

var _shortOut = createCommonjsModule(function (module) {
/** Used to detect hot functions by number of calls within a span of milliseconds. */
var HOT_COUNT = 500,
    HOT_SPAN = 16;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeNow = Date.now;

/**
 * Creates a function that'll short out and invoke `identity` instead
 * of `func` when it's called `HOT_COUNT` or more times in `HOT_SPAN`
 * milliseconds.
 *
 * @private
 * @param {Function} func The function to restrict.
 * @returns {Function} Returns the new shortable function.
 */
function shortOut(func) {
  var count = 0,
      lastCalled = 0;

  return function() {
    var stamp = nativeNow(),
        remaining = HOT_SPAN - (stamp - lastCalled);

    lastCalled = stamp;
    if (remaining > 0) {
      if (++count >= HOT_COUNT) {
        return arguments[0];
      }
    } else {
      count = 0;
    }
    return func.apply(undefined, arguments);
  };
}

module.exports = shortOut;
});

var _shortOut$1 = interopDefault(_shortOut);


var require$$0$48 = Object.freeze({
	default: _shortOut$1
});

var _setToString = createCommonjsModule(function (module) {
var baseSetToString = interopDefault(require$$1$30),
    shortOut = interopDefault(require$$0$48);

/**
 * Sets the `toString` method of `func` to return `string`.
 *
 * @private
 * @param {Function} func The function to modify.
 * @param {Function} string The `toString` result.
 * @returns {Function} Returns `func`.
 */
var setToString = shortOut(baseSetToString);

module.exports = setToString;
});

var _setToString$1 = interopDefault(_setToString);


var require$$0$47 = Object.freeze({
	default: _setToString$1
});

var _baseRest = createCommonjsModule(function (module) {
var identity = interopDefault(require$$0$35),
    overRest = interopDefault(require$$1$29),
    setToString = interopDefault(require$$0$47);

/**
 * The base implementation of `_.rest` which doesn't validate or coerce arguments.
 *
 * @private
 * @param {Function} func The function to apply a rest parameter to.
 * @param {number} [start=func.length-1] The start position of the rest parameter.
 * @returns {Function} Returns the new function.
 */
function baseRest(func, start) {
  return setToString(overRest(func, start, identity), func + '');
}

module.exports = baseRest;
});

var _baseRest$1 = interopDefault(_baseRest);


var require$$1$28 = Object.freeze({
	default: _baseRest$1
});

var _isIterateeCall = createCommonjsModule(function (module) {
var eq = interopDefault(require$$3$1),
    isArrayLike = interopDefault(require$$2$12),
    isIndex = interopDefault(require$$1$13),
    isObject = interopDefault(require$$0$4);

/**
 * Checks if the given arguments are from an iteratee call.
 *
 * @private
 * @param {*} value The potential iteratee value argument.
 * @param {*} index The potential iteratee index or key argument.
 * @param {*} object The potential iteratee object argument.
 * @returns {boolean} Returns `true` if the arguments are from an iteratee call,
 *  else `false`.
 */
function isIterateeCall(value, index, object) {
  if (!isObject(object)) {
    return false;
  }
  var type = typeof index;
  if (type == 'number'
        ? (isArrayLike(object) && isIndex(index, object.length))
        : (type == 'string' && index in object)
      ) {
    return eq(object[index], value);
  }
  return false;
}

module.exports = isIterateeCall;
});

var _isIterateeCall$1 = interopDefault(_isIterateeCall);


var require$$0$49 = Object.freeze({
	default: _isIterateeCall$1
});

var sortBy = createCommonjsModule(function (module) {
var baseFlatten = interopDefault(require$$3$12),
    baseOrderBy = interopDefault(require$$2$21),
    baseRest = interopDefault(require$$1$28),
    isIterateeCall = interopDefault(require$$0$49);

/**
 * Creates an array of elements, sorted in ascending order by the results of
 * running each element in a collection thru each iteratee. This method
 * performs a stable sort, that is, it preserves the original sort order of
 * equal elements. The iteratees are invoked with one argument: (value).
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Collection
 * @param {Array|Object} collection The collection to iterate over.
 * @param {...(Function|Function[])} [iteratees=[_.identity]]
 *  The iteratees to sort by.
 * @returns {Array} Returns the new sorted array.
 * @example
 *
 * var users = [
 *   { 'user': 'fred',   'age': 48 },
 *   { 'user': 'barney', 'age': 36 },
 *   { 'user': 'fred',   'age': 40 },
 *   { 'user': 'barney', 'age': 34 }
 * ];
 *
 * _.sortBy(users, [function(o) { return o.user; }]);
 * // => objects for [['barney', 36], ['barney', 34], ['fred', 48], ['fred', 40]]
 *
 * _.sortBy(users, ['user', 'age']);
 * // => objects for [['barney', 34], ['barney', 36], ['fred', 40], ['fred', 48]]
 */
var sortBy = baseRest(function(collection, iteratees) {
  if (collection == null) {
    return [];
  }
  var length = iteratees.length;
  if (length > 1 && isIterateeCall(collection, iteratees[0], iteratees[1])) {
    iteratees = [];
  } else if (length > 2 && isIterateeCall(iteratees[0], iteratees[1], iteratees[2])) {
    iteratees = [iteratees[0]];
  }
  return baseOrderBy(collection, baseFlatten(iteratees, 1), []);
});

module.exports = sortBy;
});

var sortBy$1 = interopDefault(sortBy);

class ClassComponent$1 extends MemberContainerComponent {

  render($$) {
    const node = this.props.node;
    const doc = node.getDocument()
    const el = $$('div')
      .addClass('sc-class')
      .attr("data-id", this.props.node.id);
    // class header
    el.append($$(HeadingComponent, {node: node}));
    // the description
    el.append(
      $$('div').addClass('se-description').html(doc.prepareHTML(node.description))
    );
    // useage block
    el.append(this.renderUsage($$));

    if (node.members && node.members.length > 0) {
      // member index
      // el.append($$(MemberIndexComponent, {node: node}));
      // members
      el.append(this._renderMembers($$));
    }

    return el;
  };

  /**
    Can be overridden by custom components.

    @see SubstanceClassComponent, which gives special treatment to @component classes
  */
  renderUsage($$) {
    var node = this.props.node;
    var el = $$('div').addClass('se-usage');
    if (node.example) {
      el.append($$(ExampleComponent, {node: node}));
    }
    return el;
  };

}

class SubstanceClassComponent extends ClassComponent$1 {

  renderUsage($$) {
    var node = this.props.node
    var el = $$('div').addClass('se-usage')
    if (node.getSpecificType() === 'component') {
      var props = this.collectTagsByType('prop')
      var stateProps = this.collectTagsByType('state')
      if (props.length > 0) {
        el.append($$(ParamsComponent, {label: 'props', params: props}))
      }
      if (stateProps.length > 0) {
        el.append($$(ParamsComponent, {label: 'state', params: stateProps}))
      }
    }
    if (node.example) {
      el.append($$(ExampleComponent, {node: node}))
    }
    return el
  }

  collectTagsByType(tagType) {
    var tagValues = []
    this.props.node.tags.forEach(function(tag) {
      if (tag.type === tagType) {
        tagValues.push(tag.value)
      }
    })
    return tagValues
  }

}

class MethodComponent extends substance.Component {

  render($$) {
    const node = this.props.node
    const doc = node.getDocument()
    const parent = node.getParent()
    const idProvider = this.context.idProvider
    const el = $$('div')
      .addClass('sc-method')
      .attr("data-id", node.id)
    if (idProvider) el.attr('id', idProvider.getId(node))

    // signature
    el.append($$(SignatureComponent, {node: node}))

    // the description
    el.append(
      $$('div').addClass('se-description').html(doc.prepareHTML(node.description))
    )

    // param description
    if (node.params.length > 0 || node.returns) {
      el.append($$(ParamsComponent, {params: node.params, returns: node.returns}))
    }

    if (node.example) {
      el.append($$(ExampleComponent, {node:node}))
    }

    return el
  }

}

class ConstructorComponent extends MethodComponent {}

class ModuleComponent extends substance.Component {

  render($$) {

    const node = this.props.node
    const doc = node.getDocument()
    const el = $$('div')
      .addClass('sc-module')
      .attr("data-id", node.id)

    // heading
    el.append($$(HeadingComponent, {node: node}))
    // description
    el.append(
      $$('div').addClass('se-description').html(doc.prepareHTML(node.description))
    )
    // example
    if (node.example) {
      el.append($$(ExampleComponent, {node:node}))
    }
    // members
    if (node.members && node.members.length > 0) {
      // members
      el.append(this._renderMembers($$))
    }

    return el
  }

  _renderMembers($$) {
    const node = this.props.node
    const members = node.getMembers()
    return members.map((node) => {
      const ComponentClass = this.getComponent(node.type)
      return $$(ComponentClass, { node:node })
    })
  }
}

class PropertyComponent extends substance.Component {

  render($$) {
    const node = this.props.node
    const doc = node.getDocument()
    const idProvider = this.context.idProvider
    const el = $$('div')
      .addClass('sc-property')
      .attr("data-id", node.id)
    if (idProvider) el.attr('id', idProvider.getId(node))
    const info = Documentation.getNodeInfo(node)
    const visibility = node.isPrivate ? "private " : ""

    // declaration
    el.append(
      $$('div').addClass('se-declaration')
        .append($$('span').addClass('se-visibility').append(visibility))
        .append($$('span').addClass('se-storage').append(info.storage))
        .append($$('span').addClass('se-name').append(node.name))
    )
    el.append(
      $$('div').addClass('se-source').append(
        $$('strong').append('Property'),
        $$('span').append(' defined in '),
        $$(SourceLinkComponent, {node: node})
      )
    )

    // description
    el.append($$('div').addClass('se-description').html(doc.prepareHTML(node.description)))
    // example
    if (node.example) {
      el.append($$(ExampleComponent, {node: node}))
    }

    return el
  }

}

class EventComponent extends substance.Component {

  render($$) {
    const node = this.props.node
    const doc = node.getDocument()
    const el = $$('div')
      .addClass('sc-method')
      .attr("data-id", node.id)

    el.append(
      $$('div').addClass('sc-signature').append(
        $$('a').attr({href: '#'}).addClass('se-declaration')
          .on('click', this.onClick)
          .append($$('span').addClass('se-name').append(node.name)),
        $$('div').addClass('se-source').append(
          $$('strong').append(this.getLabel('event')),
          $$('span').append(' defined in '),
          $$(SourceLinkComponent, {node: node})
        )
      )
    )

    // the description
    el.append(
      $$('div').addClass('se-description').html(doc.prepareHTML(node.description))
    )
    // param description
    if (node.params.length > 0 || node.returns) {
      el.append($$(ParamsComponent, {params: node.params, returns: node.returns}))
    }
    // example
    if (node.example) {
      el.append($$(ExampleComponent, {node:node}))
    }

    return el
  }

  onClick(e) {
    e.preventDefault()
    e.stopPropagation()
    this.send('focusNode', this.props.node.id)
  }

}

var DocumentationReaderPackage = {
  name: 'documentation',
  configure: function(config) {
    config.import(substance.BasePackage)
    config.import(DocumentationPackage)

    config.addComponent('page', ContentComponent)
    config.addComponent('api-page', APIPageComponent)
    config.addComponent('section', ContentComponent)
    config.addComponent('file', FileComponent)
    config.addComponent('function', FunctionComponent)
    config.addComponent('class', SubstanceClassComponent)
    config.addComponent('ctor', ConstructorComponent)
    config.addComponent('method', MethodComponent)
    config.addComponent('module', ModuleComponent)
    config.addComponent('property', PropertyComponent)
    config.addComponent('event', EventComponent)
    config.addLabel('inherited-from', 'Inherited from')
    config.addLabel('example', 'Example')
    config.addLabel('parameters', 'Parameters')
    config.addLabel('abstract-class', 'Abstract Class')
    config.addLabel('component', 'Component')
    config.addLabel('components', 'Components')
    config.addLabel('abstract-component', 'Abstract Component')
    config.addLabel('ctor', 'Constructor')
    config.addLabel('function', 'Function')
    config.addLabel('functions', 'Functions')
    config.addLabel('method', 'Method')
    config.addLabel('module', 'Module')
    config.addLabel('event', 'Event')
    config.addLabel('defined-in', 'defined in')
    config.addLabel('returns', 'Returns')
    config.addLabel('extends', 'inherits from')
    config.addLabel('inner-classes', 'Inner Classes')
    config.addLabel('class-properties', 'Class properties')
    config.addLabel('class-methods', 'Class methods')
    config.addLabel('class', 'Class')
    config.addLabel('classes', 'Classes')
    config.addLabel('method', 'Method')
    config.addLabel('methods', 'Methods')
    config.addLabel('module', 'Module')
    config.addLabel('modules', 'Modules')
    config.addLabel('property', 'Property')
    config.addLabel('properties', 'Properties')
    config.addLabel('instance-methods', 'Methods')
    config.addLabel('instance-properties', 'Properties')
    config.addLabel('instance-events', 'Events')
    config.addLabel('inherited-instance-methods', 'Inherited Methods')
    config.addLabel('inherited-instance-properties', 'Inherited Properties')
    config.addLabel('inherited-class-properties', 'Inherited Class properties')
    config.addLabel('inherited-class-methods', 'Inherited Class methods')
    config.addLabel('props', 'Props')
    config.addLabel('state', 'State')
  }
}

const reader = new ___dist_vendor_js.commonmark.Parser()
const writer = new ___dist_vendor_js.commonmark.HtmlRenderer()

const converter = {
  toHtml: function(text) {
    var parsed = reader.parse(text)
    highlightCodeblocks(parsed)
    makeLinksExternal(parsed)
    return writer.render(parsed)
  }
}

function highlightCodeblocks(parsed) {
  const walker = parsed.walker()
  let event, node
  while ((event = walker.next())) {
    node = event.node
    if (node.type === 'CodeBlock') {
      const info = node.info ? node.info.split(/\s+/) : []
      const lang = info[0]
      let highlighted
      const classes = ['hljs']

      if (lang) {
        highlighted = ___dist_vendor_js.highlightjs.highlight(lang, node.literal).value
        classes.push('lang-'+lang)
      } else {
        highlighted = ___dist_vendor_js.highlightjs.highlightAuto(node.literal).value
      }

      const htmlBlock = new ___dist_vendor_js.commonmark.Node('HtmlBlock', node.sourcepos)
      htmlBlock.literal = ['<pre>', '<code class="'+classes.join(' ')+'">', highlighted, '</code>', '</pre>'].join('')
      node.insertBefore(htmlBlock)
      node.unlink()
    }
  }
}

function makeLinksExternal(parsed) {
  const walker = parsed.walker()
  let event, node
  while ((event = walker.next())) {
    node = event.node
    if (event.entering && node.type === 'Link') {
      const href = node.destination
      let text = href
      if (node.firstChild) {
        text = node.firstChild.literal
      }
      const el = new ___dist_vendor_js.commonmark.Node('Html')
      el.literal = ['<a href="', href, '" target="_blank">', text, '</a>'].join('')
      node.insertBefore(el)
      node.unlink()
    }
  }
}

const _typeTagMatcher = /^\s*(\{[^@][^{]+\})\s+([\w\/]+)\s+(.+)/

function parseComment(comment) {
  const firstLineBreak = comment.indexOf("\n")
  if (firstLineBreak >= 0) {
    comment = comment.slice(firstLineBreak+1)
  }
  let data = ___dist_vendor_js.dox.parseComment(comment)
  const tags = data.tags
  const refinedTags = []
  data.params = []
  data.tags = refinedTags
  for (let i = 0; i < tags.length; i++) {
    let tag = tags[i]
    switch (tag.type) {
      case 'param':
        data.params.push(_extractParam(tag))
        break
      case 'return':
      case 'returns':
        // TODO: in dox a type can have multiple entries
        var returnVal = {
          type: tag.types.join('|'),
          description: tag.description
        }
        refinedTags.push({ type: 'returns', value: returnVal })
        data.returns = returnVal
        break
      case 'module':
        data.isModule = true
        break
      case 'event':
        data.isEvent = true
        break
      case 'abstract':
        data.isAbstract = true
        break
      case 'private':
        data.isPrivate = true
        break
      case 'see':
        data.see = tag.string
        break
      case 'example':
        data.example = _extractExample(tag.string)
        break
      case 'type':
        data.dataType = tag.string
        break
      default:
        var typeDescription = _typeTagMatcher.exec(tag.string)
        if (typeDescription) {
          tag.name = typeDescription[2]
          tag.description = typeDescription[3]
          ___dist_vendor_js.dox.parseTagTypes(typeDescription[1], tag)
          var customParam = _extractParam(tag)
          refinedTags.push({ type: tag.type, value: customParam })
        } else {
          refinedTags.push({ type: tag.type, value: tag.string })
        }
    }
  }
  return data
}

var dox_parseTagTypes = ___dist_vendor_js.dox.parseTagTypes
___dist_vendor_js.dox.parseTagTypes = parseTagTypes
___dist_vendor_js.dox.setMarkdownConverter(converter)

function parseTagTypes(str, tag) {
  if (/\{[^{]+\}/.exec(str)) {
    str = str.replace(/\//g, '_SEP_')
    str = str.replace(/\[\]/g, '_ARR_')
    try {
      var types = dox_parseTagTypes(str, tag)
      for (var i = 0; i < types.length; i++) {
        types[i] = types[i].replace(/_SEP_/g, '/')
        types[i] = types[i].replace(/_ARR_/g, '[]')
      }
    } catch (err) {
      throw new Error('Could not parse jsdoc expression: ' + str + "\n" + err.message)
    }
  } else {
    return dox_parseTagTypes(str, tag)
  }
}

function _extractParam(tag) {
  const shortTypes = tag.types.map(function(type) {
    const idx = type.lastIndexOf('/')
    if (idx > 0) {
      return type.slice(idx+1)
    } else {
      return type
    }
  })
  var param = {
    type: tag.types.join('|'),
    shortType: shortTypes.join('|'),
    name: tag.name,
    description: converter.toHtml(tag.description)
  }
  if (tag.optional) {
    // param.name = param.name.replace(/[\[\]]/g, '')
    param.optional = true
  }
  return param
}

function _extractExample(str) {
  const firstLineBreak = str.indexOf("\n")
  // var header
  let body
  if (firstLineBreak >= 0) {
    // header = str.slice(0, firstLineBreak).trim()
    body = str.slice(firstLineBreak)
    body = ___dist_vendor_js.dox.trimIndentation(body)
  } else {
    // header = undefined
    body = str.trim()
  }
  return converter.toHtml(body)
}

const STAR = '*'.charCodeAt(0)

/*
  Takes an `estree` AST and creates Documentation nodes
*/
class APIGenerator {

  constructor(apiPage) {
    this.apiPage = apiPage
    this.doc = apiPage.getDocument()
  }

  addJS(fileId, src) {
    fileId = fileId.replace(/\\/g, "/")
    const comments = []
    const ast = ___dist_vendor_js.acorn.parse(src, {
      ecmaVersion: 6,
      sourceType: "module",
      locations: true,
      onComment: function(block, text, start, end) {
        // only record block comments starting with /**
        if (block && text.charCodeAt(0) === STAR) {
          text = text.slice(1)
          comments.push({ start: start, end: end, text: text })
        }
      }
    })
    const walker = new Walker(this.doc, this.apiPage, fileId, comments)
    walker.walk(ast)
    // depending on the exports we create a ModuleNode
    // so that we can create minimal ids
    // only export default -> we use the fileId for the exported item (function, class, or object)
    // only named exports -> we create a module
    const hasDefaultExport = walker._exportDefault
    if (Object.keys(walker._items).length>0 && !hasDefaultExport) {
      console.error('ATM we support only modules with default export (one-class per file, and module as object): ', fileId)
    }
    if (hasDefaultExport) {
      const _export = walker._items[walker._exportDefault]
      if (_export) this._create(fileId, _export)
    }
  }

  // called to actually create a class or module node
  _create(fileId, item) {
    // use the fileId
    const doc = this.doc
    const id = fileId.replace(/\.js$/, "")
    const apiId = this.apiPage.id
    item.id = id
    item.api = apiId
    const members = item.members
    delete item.members
    const node = doc.create(item)
    if (item.type === 'class') {
      node.members = members.map(function(m) {
        m.parent = id
        m.api = apiId
        const sep = m.isStatic ? '.' : '#'
        if (m.type === 'ctor') {
          m.id = id+"()"
        } else if (m.type === 'method') {
          m.id = id+sep+m.name+"()"
        } else if (m.type === 'property') {
          m.id = id+sep+m.name
        } else {
          throw new Error('Internal error.')
        }
        doc.create(m)
        return m.id
      })
    } else if (item.type === 'module') {
      node.members = members.map(function(m) {
        m.parent = id
        m.api = apiId
        const sep = '.'
        if (m.type === 'function') {
          m.id = id+sep+m.name+"()"
        } else if (m.type === 'property') {
          m.id = id+sep+m.name
        } else {
          throw new Error('Internal error.')
        }
        doc.create(m)
        return m.id
      })
    }
  }
}

class Walker {

  constructor(doc, apiPage, fileId, comments) {
    this.doc = doc
    this.apiPage = apiPage
    this.fileId = fileId
    this.comments = comments

    this._items = {}
    this._clazz = null
    this._exportDefault = null
  }

  enter(node, parent, context) {
    const comments = this.comments
    let comment = null
    if (comments.length > 0 && comments[0].start < node.start) {
      comment = comments.shift()
    }
    if (comment) {
      comment = parseComment(comment.text)
    }
    switch(node.type) {
      // function defined in a module
      case 'FunctionDeclaration':
        this._function({ name: node.id.name, loc: node.loc }, comment)
        context.skip()
        this.leave(node)
        break
      case 'ClassDeclaration':
        if (this._class(node, comment) === false) {
          context.skip()
          this.leave(node)
        }
        break
      // method = member function
      case 'MethodDefinition':
        switch(node.kind) {
          case 'constructor':
            this._ctor(node, comment)
            break
          case 'get':
            this._property({ name: node.key.name, loc: node.loc, isStatic: node.static }, comment)
            break
          case 'method':
            this._method({ name: node.key.name, kind: node.kind, loc: node.loc }, comment)
            break
          default:
            //
        }
        context.skip()
        // Note: skipping prevents this.leave() getting called
        // which is necessary, to cleanup skipped comments
        this.leave(node)
        break
      // analyze assignments on module level to
      // detect static props and methods
      // TODO: we should also look for Object.defineProperties etc
      // and for old school Class.prototype.property
      case 'ExpressionStatement':
        if (node.expression.type === 'AssignmentExpression') {
          const expr = node.expression
          if (expr.left.type === 'MemberExpression' &&
              expr.left.object.type === 'Identifier' &&
              expr.left.property.type === 'Identifier') {
            const assignee = expr.left.object.name
            const name = expr.left.property.name
            const item = this._items[assignee]
            if (item && item.type === 'class') {
              // Foo.bar = function() {}
              if (expr.right.type === 'FunctionExpression') {
                this._method({ name: name, kind: 'method', loc: expr.loc, isStatic: true, clazz: item }, comment)
              }
              // Foo.bar = "baz"
              else {
                this._property({ name: name, loc: expr.loc, isStatic: true, clazz: item }, comment)
              }
            } else if (item && item.type === 'module') {
              // mymodule.foo = function() {}
              if (expr.right.type === 'FunctionExpression') {
                this._function({ name: name, loc: expr.loc, module: item }, comment)
              }
            } else {
              // console.log('### AssignmentExpression', expr)
            }
          } else {
            // console.log('### AssignmentExpression', expr)
          }
        } else {
          // console.log('### ExpressionStatement', node)
        }
        context.skip()
        this.leave(node)
        break
      case 'VariableDeclaration':
        if (comment && comment.isModule) {
          const name = node.declarations[0].id.name
          this._module({ name: name, loc: node.loc }, comment)
        } else {
          // console.log('### VariableDeclaration', this.fileId, node)
        }
        context.skip()
        break
      case 'ExportNamedDeclaration':
        // console.log('### ExportNamedDeclaration', this.fileId, node)
        context.skip()
        break
      case 'ExportDefaultDeclaration':
        this._exportDefault = node.declaration.name
        context.skip()
        break
      case 'Program':
      case 'ClassBody':
        break
      case 'EmptyStatement':
      case 'IfStatement':
      case 'ImportDeclaration':
      case 'Identifier':
        context.skip()
        break
      default:
        console.warn('Unsupported expression in %s at line %s column %s', this.fileId, node.loc.start.line, node.loc.start.column)
        // console.log(node)
    }
  }

  leave(node) {
    // remove any comments found on skipped/passed nodes
    const comments = this.comments
    while( comments.length > 0 && comments[0].start < node.end ) {
      comments.shift()
    }
    switch(node.type) {
      case 'ClassDeclaration':
        this._clazz = null
        break
      default:
        // nothing
    }
  }

  _module(data, comment) {
    // skip undocumented classes
    if (!comment) return false
    const name = data.name
    const mod = {
      type: 'module',
      name: name,
      members: [],
      sourceFile: this.fileId,
      sourceLine: data.loc.start.line,
      description: comment.description.full,
      example: comment.example,
      tags: comment.tags,
    }
    this._items[name] = mod
  }

  _class(node, comment) {
    const name = node.id.name
    const superClass = node.superClass ? node.superClass.name : null
    const clazz = {
      type: 'class',
      name: name,
      members: [],
      sourceFile: this.fileId,
      sourceLine: node.loc.start.line,
      superClass: superClass,
    }
    if (comment) {
      Object.assign(clazz, {
        description: comment.description.full,
        isAbstract: comment.isAbstract,
        example: comment.example,
        tags: comment.tags,
      })
    } else {
      clazz.isUndocumented = true
    }
    this._clazz = clazz
    this._items[name] = clazz
  }

  _ctor(node, comment) {
    const clazz = this._clazz
    const fileId = this.fileId
    const ctor = {
      type: 'ctor',
      parent: clazz,
      sourceFile: fileId,
      sourceLine: node.loc.start.line,
      name: clazz.name
    }
    if (comment) {
      ctor.description = comment.description.full
      ctor.example = comment.example
      ctor.tags = comment.tags
    }
    clazz.members.push(ctor)
  }

  _method(data, comment) {
    // skip undocumented methods
    if (!comment) return
    const clazz = this._clazz || data.clazz
    const name = data.name
    const fileId = this.fileId
    const isStatic = Boolean(data.isStatic)
    const method = {
      type: 'method',
      parent: clazz,
      sourceFile: fileId,
      sourceLine: data.loc.start.line,
      name: name,
      description: comment.description.full,
      params: comment.params,
      returns: comment.returns,
      isStatic: isStatic,
      tags: comment.tags,
      example: comment.example,
    }
    clazz.members.push(method)
  }

  _property(data, comment) {
    // skip undocumented functions
    if (!comment) return
    const clazz = this._clazz || data.clazz
    const name = data.name
    const fileId = this.fileId
    const isStatic = Boolean(data.isStatic)
    const prop = {
      type: 'property',
      parent: clazz,
      sourceFile: fileId,
      sourceLine: data.loc.start.line,
      name: name,
      description: comment.description.full,
      dataType: comment.dataType,
      isStatic: isStatic,
      tags: comment.tags,
      example: comment.example,
    }
    clazz.members.push(prop)
  }

  _function(data, comment) {
    // skip undocumented functions
    if (!comment) return
    const fileId = this.fileId
    const name = data.name
    const fun = {
      type: 'function',
      sourceFile: fileId,
      sourceLine: data.loc.start.line,
      name: name,
      description: comment.description.full,
      params: comment.params,
      returns: comment.returns,
      example: comment.example,
      tags: comment.tags,
    }
    if (data.module) {
      data.module.members.push(fun)
    } else {
      this._items[name] = fun
    }
  }

  walk(ast) {
    const self = this
    ___dist_vendor_js.estreeWalker.walk(ast, {
      enter: function(node, parent) {
        self.enter(node, parent, this)
      },
      leave: function(node, parent) {
        self.leave(node, parent, this)
      }
    })
  }
}

function generateDocumentation(config, sources) {
  const doc = new Documentation(config)
  const pages = doc.get('pages')
  let currentPage = null
  config.content.forEach(function(item) {
    switch (item.type) {
      case 'page':
        currentPage = _page(doc, sources, item)
        pages.nodes.push(currentPage.id)
        break
      case 'section':
        if (!currentPage) throw new Error('Create a page first.')
        _section(doc, sources, currentPage, item)
        break
      case 'api':
        currentPage = _api(doc, sources, item)
        pages.nodes.push(currentPage.id)
        currentPage = null
        break
      default:
        console.error('Unsupported documentation type', item.type)
    }
  })
  return doc
}

function _page(doc, sources, item) {
  const src = sources[item.src]
  const html = src ? converter.toHtml(src) : ''
  return doc.create({
    type: 'page',
    id: item.id,
    title: item.title,
    description: html
  })
}

function _section(doc, sources, page, item) {
  const src = sources[item.src]
  const html = src ? converter.toHtml(src) : ''
  const sec = doc.create({
    type: 'section',
    id: item.id,
    page: page.id,
    title: item.title,
    level: item.level,
    description: html
  })
  page.sections.push(sec.id)
  return sec
}

function _api(doc, sources, item) {
  const src = sources[item.src]
  const fileList = Object.keys(sources)
  const html = src ? converter.toHtml(src) : ''
  const apiPage = doc.create({
    type: 'api-page',
    id: item.id || 'api',
    description: html
  })
  const generator = new APIGenerator(apiPage)
  let files = item.files.map(function(file) {
    if (file.indexOf('*')>-1) {
      return fileList.filter(___dist_vendor_js.minimatch.filter(file))
    } else {
      return file
    }
  })
  files = Array.prototype.concat.apply([], files)
  files.sort()
  files.forEach(function(fileId) {
    const src = sources[fileId]
    if (src) {
      generator.addJS(fileId, src)
    }
  })
  return apiPage
}

substance.substanceGlobals.DEBUG_RENDERING = true

// This is used during development, to have the full generation
// done in the browser
function _generateDocumentation() {
  const sources = window.SOURCES
  const config = window.CONFIG
  return generateDocumentation(config, sources)
}

// This is can be used to serve a previously generated
// documentation and just render it dynamically
function _importDocumentation() {
  const config = window.CONFIG
  const data = window.DOCUMENTATION
  const converter = new substance.JSONConverter()
  const doc = new Documentation(config)
  return converter.importDocument(doc, data)
  return doc
}

function _openReader(doc) {
  var configurator = new substance.Configurator().import(DocumentationReaderPackage)
  DocumentationReader.mount({
    doc: doc,
    configurator: configurator
  }, window.document.body)
}

window.addEventListener('load', function() {
  var doc
  if (!window.DOCUMENTATION) {
    doc = _generateDocumentation()
  } else {
    doc = _importDocumentation()
  }
  window.doc = doc
  _openReader(doc)
})

})));

//# sourceMappingURL=./reader.js.map